/* ListStatusesPage.c generated by valac 0.56.3, the Vala compiler
 * generated from ListStatusesPage.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include "CbMessageReceiver.h"
#include <glib-object.h>
#include "CbUserStream.h"
#include <json-glib/json-glib.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include "CbTweet.h"
#include "CbBundle.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <atk/atk.h>
#include "CbTweetModel.h"
#include <rest/rest-proxy-call.h>
#include <rest/oauth-proxy.h>
#include <rest/rest-proxy.h>
#include "CbUtils.h"

#define LIST_STATUSES_PAGE_KEY_USER_LIST 0
#define LIST_STATUSES_PAGE_KEY_NAME 1
#define LIST_STATUSES_PAGE_KEY_DESCRIPTION 2
#define LIST_STATUSES_PAGE_KEY_CREATOR 3
#define LIST_STATUSES_PAGE_KEY_N_SUBSCRIBERS 4
#define LIST_STATUSES_PAGE_KEY_N_MEMBERS 5
#define LIST_STATUSES_PAGE_KEY_CREATED_AT 6
#define LIST_STATUSES_PAGE_KEY_MODE 7
#define LIST_STATUSES_PAGE_KEY_LIST_ID 8
#define LIST_STATUSES_PAGE_KEY_TITLE 9
#define LISTS_PAGE_KEY_MODE 0
#define LISTS_PAGE_MODE_DELETE 1
#define LISTS_PAGE_KEY_LIST_ID 1
#define TWEET_INFO_PAGE_KEY_MODE 0
#define TWEET_INFO_PAGE_BY_INSTANCE 1
#define TWEET_INFO_PAGE_KEY_TWEET 1

#define TYPE_LIST_STATUSES_PAGE (list_statuses_page_get_type ())
#define LIST_STATUSES_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIST_STATUSES_PAGE, ListStatusesPage))
#define LIST_STATUSES_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIST_STATUSES_PAGE, ListStatusesPageClass))
#define IS_LIST_STATUSES_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIST_STATUSES_PAGE))
#define IS_LIST_STATUSES_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIST_STATUSES_PAGE))
#define LIST_STATUSES_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIST_STATUSES_PAGE, ListStatusesPageClass))

typedef struct _ListStatusesPage ListStatusesPage;
typedef struct _ListStatusesPageClass ListStatusesPageClass;
typedef struct _ListStatusesPagePrivate ListStatusesPagePrivate;
enum  {
	LIST_STATUSES_PAGE_0_PROPERTY,
	LIST_STATUSES_PAGE_ID_PROPERTY,
	LIST_STATUSES_PAGE_WINDOW_PROPERTY,
	LIST_STATUSES_PAGE_NUM_PROPERTIES
};
static GParamSpec* list_statuses_page_properties[LIST_STATUSES_PAGE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
typedef struct _ListStatusesPageLoadNewestData ListStatusesPageLoadNewestData;
typedef struct _ListStatusesPageLoadOlderData ListStatusesPageLoadOlderData;
typedef struct _Block25Data Block25Data;
typedef enum  {
	PAGE_STREAM = 0,
	PAGE_MENTIONS,
	PAGE_FAVORITES,
	PAGE_DM_THREADS,
	PAGE_LISTS,
	PAGE_FILTERS,
	PAGE_SEARCH,
	PAGE_PROFILE,
	PAGE_TWEET_INFO,
	PAGE_DM,
	PAGE_LIST_STATUSES,
	PAGE_PREVIOUS = 1024,
	PAGE_NEXT = 2048
} Page;

#define TYPE_PAGE (page_get_type ())
typedef struct _ListStatusesPageLoadNewerData ListStatusesPageLoadNewerData;

struct _ListStatusesPage {
	ScrollWidget parent_instance;
	ListStatusesPagePrivate * priv;
	Account* account;
};

struct _ListStatusesPageClass {
	ScrollWidgetClass parent_class;
	void (*stream_message_received) (ListStatusesPage* self, CbStreamMessageType type, JsonNode* root);
};

struct _ListStatusesPagePrivate {
	gint _id;
	MainWindow* main_window;
	gint64 list_id;
	guint tweet_remove_timeout;
	TweetListBox* tweet_list;
	GtkMenuButton* delete_button;
	GtkButton* edit_button;
	GtkLabel* description_label;
	GtkLabel* title_label;
	GtkLabel* creator_label;
	GtkLabel* subscribers_label;
	GtkLabel* members_label;
	GtkLabel* created_at_label;
	GtkStack* title_stack;
	GtkEntry* title_entry;
	GtkStack* description_stack;
	GtkEntry* description_entry;
	GtkStack* delete_stack;
	GtkButton* cancel_button;
	GtkStack* edit_stack;
	GtkButton* save_button;
	GtkStack* mode_stack;
	GtkLabel* mode_label;
	GtkComboBoxText* mode_combo_box;
	GtkButton* refresh_button;
	gboolean loading;
};

struct _ListStatusesPageLoadNewestData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ListStatusesPage* self;
	TweetListBox* _tmp0_;
	guint requested_tweet_count;
	RestProxyCall* call;
	Account* _tmp1_;
	OAuthProxy* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	RestProxyCall* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	RestProxyCall* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	RestProxyCall* _tmp14_;
	RestProxyCall* _tmp15_;
	JsonNode* root;
	JsonNode* _tmp16_;
	RestProxyCall* _tmp17_;
	JsonNode* _tmp18_;
	JsonNode* _tmp19_;
	GError* e;
	GError* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gboolean _tmp24_;
	TweetListBox* _tmp25_;
	GError* _tmp26_;
	const gchar* _tmp27_;
	JsonArray* root_array;
	JsonNode* _tmp28_;
	JsonArray* _tmp29_;
	JsonArray* _tmp30_;
	JsonArray* _tmp31_;
	TweetListBox* _tmp32_;
	JsonArray* _tmp33_;
	TweetListBox* _tmp34_;
	Account* _tmp35_;
	GError* _inner_error0_;
};

struct _ListStatusesPageLoadOlderData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ListStatusesPage* self;
	guint requested_tweet_count;
	RestProxyCall* call;
	Account* _tmp0_;
	OAuthProxy* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	RestProxyCall* _tmp8_;
	TweetListBox* _tmp9_;
	CbTweetModel* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	RestProxyCall* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	RestProxyCall* _tmp16_;
	RestProxyCall* _tmp17_;
	JsonNode* root;
	JsonNode* _tmp18_;
	RestProxyCall* _tmp19_;
	JsonNode* _tmp20_;
	JsonNode* _tmp21_;
	GError* e;
	GError* _tmp22_;
	const gchar* _tmp23_;
	JsonArray* root_array;
	JsonNode* _tmp24_;
	JsonArray* _tmp25_;
	JsonArray* _tmp26_;
	JsonArray* _tmp27_;
	TweetListBox* _tmp28_;
	Account* _tmp29_;
	GError* _inner_error0_;
};

struct _Block25Data {
	int _ref_count_;
	ListStatusesPage* self;
	RestProxyCall* call;
};

struct _ListStatusesPageLoadNewerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ListStatusesPage* self;
	RestProxyCall* call;
	Account* _tmp0_;
	OAuthProxy* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	RestProxyCall* _tmp8_;
	RestProxyCall* _tmp9_;
	RestProxyCall* _tmp10_;
	gint64 since_id;
	TweetListBox* _tmp11_;
	CbTweetModel* _tmp12_;
	RestProxyCall* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	JsonNode* root;
	JsonNode* _tmp20_;
	RestProxyCall* _tmp21_;
	JsonNode* _tmp22_;
	JsonNode* _tmp23_;
	GError* e;
	GError* _tmp24_;
	const gchar* _tmp25_;
	JsonArray* root_array;
	JsonNode* _tmp26_;
	JsonArray* _tmp27_;
	JsonArray* _tmp28_;
	JsonArray* _tmp29_;
	JsonArray* _tmp30_;
	TweetListBox* _tmp31_;
	Account* _tmp32_;
	GError* _inner_error0_;
};

static gint ListStatusesPage_private_offset;
static gpointer list_statuses_page_parent_class = NULL;
static CbMessageReceiverInterface * list_statuses_page_cb_message_receiver_parent_iface = NULL;
static IPageIface * list_statuses_page_ipage_parent_iface = NULL;

VALA_EXTERN GType list_statuses_page_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void list_statuses_page_stream_message_received (ListStatusesPage* self,
                                                 CbStreamMessageType type,
                                                 JsonNode* root);
VALA_EXTERN ListStatusesPage* list_statuses_page_new (gint id,
                                          Account* account);
VALA_EXTERN ListStatusesPage* list_statuses_page_construct (GType object_type,
                                                gint id,
                                                Account* account);
static void list_statuses_page_load_older (ListStatusesPage* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static void list_statuses_page_load_older_finish (ListStatusesPage* self,
                                           GAsyncResult* _res_);
static void _list_statuses_page_load_older_scroll_widget_scrolled_to_end (ScrollWidget* _sender,
                                                                   gpointer self);
VALA_EXTERN void list_statuses_page_handle_scrolled_to_start (ListStatusesPage* self);
static void _list_statuses_page_handle_scrolled_to_start_scroll_widget_scrolled_to_start (ScrollWidget* _sender,
                                                                                   gdouble value,
                                                                                   gpointer self);
static void list_statuses_page_real_stream_message_received (ListStatusesPage* self,
                                                      CbStreamMessageType type,
                                                      JsonNode* root);
VALA_EXTERN void list_statuses_page_hide_tweets_from (ListStatusesPage* self,
                                          JsonNode* root,
                                          CbTweetState tweet_reason,
                                          CbTweetState retweet_reason);
VALA_EXTERN void list_statuses_page_show_tweets_from (ListStatusesPage* self,
                                          JsonNode* root,
                                          CbTweetState tweet_reason,
                                          CbTweetState retweet_reason);
static gint64 list_statuses_page_get_user_id (ListStatusesPage* self,
                                       JsonNode* root);
static void list_statuses_page_real_on_join (IPage* base,
                                      gint page_id,
                                      CbBundle* args);
static void list_statuses_page_set_mode_label (ListStatusesPage* self,
                                        const gchar* mode);
static void list_statuses_page_load_newer (ListStatusesPage* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static void list_statuses_page_load_newer_finish (ListStatusesPage* self,
                                           GAsyncResult* _res_);
static void list_statuses_page_load_newest (ListStatusesPage* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static void list_statuses_page_load_newest_finish (ListStatusesPage* self,
                                            GAsyncResult* _res_);
static void list_statuses_page_real_on_leave (IPage* base);
static void list_statuses_page_load_newest_data_free (gpointer _data);
static gboolean list_statuses_page_load_newest_co (ListStatusesPageLoadNewestData* _data_);
static void list_statuses_page_load_newest_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static void _vala_JsonNode_free (JsonNode* self);
VALA_EXTERN void tweet_utils_work_array (JsonArray* json_array,
                             TweetListBox* tweet_list,
                             Account* account);
static void list_statuses_page_load_older_data_free (gpointer _data);
static gboolean list_statuses_page_load_older_co (ListStatusesPageLoadOlderData* _data_);
static void list_statuses_page_load_older_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static void list_statuses_page_edit_button_clicked_cb (ListStatusesPage* self);
static void _list_statuses_page_edit_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void list_statuses_page_cancel_button_clicked_cb (ListStatusesPage* self);
static void _list_statuses_page_cancel_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                      gpointer self);
static void list_statuses_page_save_button_clicked_cb (ListStatusesPage* self);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void __lambda105_ (Block25Data* _data25_,
                   GObject* o,
                   GAsyncResult* res);
VALA_EXTERN void utils_show_error_dialog (GError* e,
                              GtkWindow* transient_for,
                              const gchar* file,
                              gint line);
static void ___lambda105__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void _list_statuses_page_save_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void list_statuses_page_delete_confirmation_item_clicked_cb (ListStatusesPage* self);
VALA_EXTERN void list_utils_delete_list (Account* account,
                             gint64 to_rename,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
VALA_EXTERN void list_utils_delete_list_finish (GAsyncResult* _res_,
                                    GError** error);
static void __lambda106_ (ListStatusesPage* self,
                   GObject* obj,
                   GAsyncResult* res);
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
static void ___lambda106__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void _list_statuses_page_delete_confirmation_item_clicked_cb_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                                     gpointer self);
static void list_statuses_page_refresh_button_clicked_cb (ListStatusesPage* self);
static void __lambda114_ (ListStatusesPage* self);
static void ___lambda114__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void _list_statuses_page_refresh_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void list_statuses_page_tweet_activated_cb (ListStatusesPage* self,
                                            GtkListBoxRow* row);
static void _list_statuses_page_tweet_activated_cb_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                        GtkListBoxRow* row,
                                                                        gpointer self);
static void list_statuses_page_load_newer_data_free (gpointer _data);
static gboolean list_statuses_page_load_newer_co (ListStatusesPageLoadNewerData* _data_);
static void list_statuses_page_load_newer_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static gboolean ___lambda104_ (ListStatusesPage* self);
static gboolean ____lambda104__gsource_func (gpointer self);
static gchar* list_statuses_page_real_get_title (IPage* base);
static void list_statuses_page_real_create_radio_button (IPage* base,
                                                  GtkRadioButton* group);
static GtkRadioButton* list_statuses_page_real_get_radio_button (IPage* base);
static void list_statuses_page_real_rerun_filters (IPage* base);
static void list_statuses_page_finalize (GObject * obj);
static GType list_statuses_page_get_type_once (void);
static void _vala_list_statuses_page_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_list_statuses_page_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
list_statuses_page_get_instance_private (ListStatusesPage* self)
{
	return G_STRUCT_MEMBER_P (self, ListStatusesPage_private_offset);
}

static void
_list_statuses_page_load_older_scroll_widget_scrolled_to_end (ScrollWidget* _sender,
                                                              gpointer self)
{
#line 91 "../src/ListStatusesPage.vala"
	list_statuses_page_load_older ((ListStatusesPage*) self, NULL, NULL);
#line 447 "ListStatusesPage.c"
}

static void
_list_statuses_page_handle_scrolled_to_start_scroll_widget_scrolled_to_start (ScrollWidget* _sender,
                                                                              gdouble value,
                                                                              gpointer self)
{
#line 92 "../src/ListStatusesPage.vala"
	list_statuses_page_handle_scrolled_to_start ((ListStatusesPage*) self);
#line 457 "ListStatusesPage.c"
}

ListStatusesPage*
list_statuses_page_construct (GType object_type,
                              gint id,
                              Account* account)
{
	ListStatusesPage * self = NULL;
	TweetListBox* _tmp0_;
	TweetListBox* _tmp1_;
	GtkAdjustment* _tmp2_;
#line 87 "../src/ListStatusesPage.vala"
	g_return_val_if_fail (account != NULL, NULL);
#line 87 "../src/ListStatusesPage.vala"
	self = (ListStatusesPage*) scroll_widget_construct (object_type);
#line 88 "../src/ListStatusesPage.vala"
	ipage_set_id ((IPage*) self, id);
#line 89 "../src/ListStatusesPage.vala"
	self->account = account;
#line 90 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->tweet_list;
#line 90 "../src/ListStatusesPage.vala"
	_tmp0_->account = account;
#line 91 "../src/ListStatusesPage.vala"
	g_signal_connect_object ((ScrollWidget*) self, "scrolled-to-end", (GCallback) _list_statuses_page_load_older_scroll_widget_scrolled_to_end, self, 0);
#line 92 "../src/ListStatusesPage.vala"
	g_signal_connect_object ((ScrollWidget*) self, "scrolled-to-start", (GCallback) _list_statuses_page_handle_scrolled_to_start_scroll_widget_scrolled_to_start, self, 0);
#line 93 "../src/ListStatusesPage.vala"
	_tmp1_ = self->priv->tweet_list;
#line 93 "../src/ListStatusesPage.vala"
	_tmp2_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 93 "../src/ListStatusesPage.vala"
	gtk_list_box_set_adjustment ((GtkListBox*) _tmp1_, _tmp2_);
#line 87 "../src/ListStatusesPage.vala"
	return self;
#line 493 "ListStatusesPage.c"
}

ListStatusesPage*
list_statuses_page_new (gint id,
                        Account* account)
{
#line 87 "../src/ListStatusesPage.vala"
	return list_statuses_page_construct (TYPE_LIST_STATUSES_PAGE, id, account);
#line 502 "ListStatusesPage.c"
}

static void
list_statuses_page_real_stream_message_received (ListStatusesPage* self,
                                                 CbStreamMessageType type,
                                                 JsonNode* root)
{
#line 96 "../src/ListStatusesPage.vala"
	g_return_if_fail (root != NULL);
#line 97 "../src/ListStatusesPage.vala"
	if (type == CB_STREAM_MESSAGE_EVENT_BLOCK) {
#line 98 "../src/ListStatusesPage.vala"
		list_statuses_page_hide_tweets_from (self, root, CB_TWEET_STATE_HIDDEN_AUTHOR_BLOCKED, CB_TWEET_STATE_HIDDEN_RETWEETER_BLOCKED);
#line 516 "ListStatusesPage.c"
	} else {
#line 99 "../src/ListStatusesPage.vala"
		if (type == CB_STREAM_MESSAGE_EVENT_UNBLOCK) {
#line 100 "../src/ListStatusesPage.vala"
			list_statuses_page_show_tweets_from (self, root, CB_TWEET_STATE_HIDDEN_AUTHOR_BLOCKED, CB_TWEET_STATE_HIDDEN_RETWEETER_BLOCKED);
#line 522 "ListStatusesPage.c"
		} else {
#line 101 "../src/ListStatusesPage.vala"
			if (type == CB_STREAM_MESSAGE_EVENT_MUTE) {
#line 102 "../src/ListStatusesPage.vala"
				list_statuses_page_hide_tweets_from (self, root, CB_TWEET_STATE_HIDDEN_AUTHOR_MUTED, CB_TWEET_STATE_HIDDEN_RETWEETER_MUTED);
#line 528 "ListStatusesPage.c"
			} else {
#line 103 "../src/ListStatusesPage.vala"
				if (type == CB_STREAM_MESSAGE_EVENT_UNMUTE) {
#line 104 "../src/ListStatusesPage.vala"
					list_statuses_page_show_tweets_from (self, root, CB_TWEET_STATE_HIDDEN_AUTHOR_MUTED, CB_TWEET_STATE_HIDDEN_RETWEETER_MUTED);
#line 534 "ListStatusesPage.c"
				} else {
#line 105 "../src/ListStatusesPage.vala"
					if (type == CB_STREAM_MESSAGE_EVENT_HIDE_RTS) {
#line 538 "ListStatusesPage.c"
						TweetListBox* _tmp0_;
#line 106 "../src/ListStatusesPage.vala"
						_tmp0_ = self->priv->tweet_list;
#line 106 "../src/ListStatusesPage.vala"
						tweet_list_box_hide_retweets_from (_tmp0_, list_statuses_page_get_user_id (self, root), CB_TWEET_STATE_HIDDEN_RTS_DISABLED);
#line 544 "ListStatusesPage.c"
					} else {
#line 107 "../src/ListStatusesPage.vala"
						if (type == CB_STREAM_MESSAGE_EVENT_SHOW_RTS) {
#line 548 "ListStatusesPage.c"
							TweetListBox* _tmp1_;
#line 108 "../src/ListStatusesPage.vala"
							_tmp1_ = self->priv->tweet_list;
#line 108 "../src/ListStatusesPage.vala"
							tweet_list_box_show_retweets_from (_tmp1_, list_statuses_page_get_user_id (self, root), CB_TWEET_STATE_HIDDEN_RTS_DISABLED);
#line 554 "ListStatusesPage.c"
						}
					}
				}
			}
		}
	}
}

void
list_statuses_page_stream_message_received (ListStatusesPage* self,
                                            CbStreamMessageType type,
                                            JsonNode* root)
{
	ListStatusesPageClass* _klass_;
#line 96 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/ListStatusesPage.vala"
	_klass_ = LIST_STATUSES_PAGE_GET_CLASS (self);
#line 96 "../src/ListStatusesPage.vala"
	if (_klass_->stream_message_received) {
#line 96 "../src/ListStatusesPage.vala"
		_klass_->stream_message_received (self, type, root);
#line 577 "ListStatusesPage.c"
	}
}

static gint64
list_statuses_page_get_user_id (ListStatusesPage* self,
                                JsonNode* root)
{
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	gint64 result;
#line 112 "../src/ListStatusesPage.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 112 "../src/ListStatusesPage.vala"
	g_return_val_if_fail (root != NULL, 0LL);
#line 113 "../src/ListStatusesPage.vala"
	_tmp0_ = json_node_get_object (root);
#line 113 "../src/ListStatusesPage.vala"
	_tmp1_ = json_object_get_object_member (_tmp0_, "target");
#line 113 "../src/ListStatusesPage.vala"
	result = json_object_get_int_member (_tmp1_, "id");
#line 113 "../src/ListStatusesPage.vala"
	return result;
#line 600 "ListStatusesPage.c"
}

void
list_statuses_page_show_tweets_from (ListStatusesPage* self,
                                     JsonNode* root,
                                     CbTweetState tweet_reason,
                                     CbTweetState retweet_reason)
{
	gint64 user_id = 0LL;
	TweetListBox* _tmp0_;
	TweetListBox* _tmp1_;
#line 116 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/ListStatusesPage.vala"
	g_return_if_fail (root != NULL);
#line 117 "../src/ListStatusesPage.vala"
	if (retweet_reason == 0) {
#line 118 "../src/ListStatusesPage.vala"
		retweet_reason = tweet_reason;
#line 620 "ListStatusesPage.c"
	}
#line 120 "../src/ListStatusesPage.vala"
	user_id = list_statuses_page_get_user_id (self, root);
#line 121 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->tweet_list;
#line 121 "../src/ListStatusesPage.vala"
	tweet_list_box_show_tweets_from (_tmp0_, user_id, tweet_reason);
#line 122 "../src/ListStatusesPage.vala"
	_tmp1_ = self->priv->tweet_list;
#line 122 "../src/ListStatusesPage.vala"
	tweet_list_box_show_retweets_from (_tmp1_, user_id, retweet_reason);
#line 632 "ListStatusesPage.c"
}

void
list_statuses_page_hide_tweets_from (ListStatusesPage* self,
                                     JsonNode* root,
                                     CbTweetState tweet_reason,
                                     CbTweetState retweet_reason)
{
	gint64 user_id = 0LL;
	TweetListBox* _tmp0_;
	TweetListBox* _tmp1_;
#line 125 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/ListStatusesPage.vala"
	g_return_if_fail (root != NULL);
#line 126 "../src/ListStatusesPage.vala"
	if (retweet_reason == 0) {
#line 127 "../src/ListStatusesPage.vala"
		retweet_reason = tweet_reason;
#line 652 "ListStatusesPage.c"
	}
#line 129 "../src/ListStatusesPage.vala"
	user_id = list_statuses_page_get_user_id (self, root);
#line 130 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->tweet_list;
#line 130 "../src/ListStatusesPage.vala"
	tweet_list_box_hide_tweets_from (_tmp0_, user_id, tweet_reason);
#line 131 "../src/ListStatusesPage.vala"
	_tmp1_ = self->priv->tweet_list;
#line 131 "../src/ListStatusesPage.vala"
	tweet_list_box_hide_retweets_from (_tmp1_, user_id, retweet_reason);
#line 664 "ListStatusesPage.c"
}

/**
   * va_list params:
   *  - int64 list_id - The id of the list to show
   *  - string name - The lists's name
   *  - bool user_list - true if the list belongs to the user, false otherwise
   *  - string description - the lists's description
   *  - string creator
   *  - int subscribers_count
   *  - int memebers_count
   *  - int64 created_at
   *  - string mode
   */
static void
list_statuses_page_real_on_join (IPage* base,
                                 gint page_id,
                                 CbBundle* args)
{
	ListStatusesPage * self;
	gint64 list_id = 0LL;
	gchar* list_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
#line 146 "../src/ListStatusesPage.vala"
	self = (ListStatusesPage*) base;
#line 147 "../src/ListStatusesPage.vala"
	list_id = cb_bundle_get_int64 (args, LIST_STATUSES_PAGE_KEY_LIST_ID);
#line 148 "../src/ListStatusesPage.vala"
	if (list_id == ((gint64) 0)) {
#line 149 "../src/ListStatusesPage.vala"
		list_id = self->priv->list_id;
#line 150 "../src/ListStatusesPage.vala"
		return;
#line 704 "ListStatusesPage.c"
	}
#line 154 "../src/ListStatusesPage.vala"
	_tmp0_ = cb_bundle_get_string (args, LIST_STATUSES_PAGE_KEY_NAME);
#line 154 "../src/ListStatusesPage.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 154 "../src/ListStatusesPage.vala"
	list_name = _tmp1_;
#line 155 "../src/ListStatusesPage.vala"
	_tmp2_ = list_name;
#line 155 "../src/ListStatusesPage.vala"
	if (_tmp2_ != NULL) {
#line 716 "ListStatusesPage.c"
		gchar* list_title = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gboolean user_list = FALSE;
		gchar* description = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* creator = NULL;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gint n_subscribers = 0;
		gint n_members = 0;
		gint64 created_at = 0LL;
		gchar* mode = NULL;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		GtkMenuButton* _tmp11_;
		GtkButton* _tmp12_;
		GtkLabel* _tmp13_;
		const gchar* _tmp14_;
		GtkLabel* _tmp15_;
		const gchar* _tmp16_;
		GtkLabel* _tmp17_;
		const gchar* _tmp18_;
		GtkLabel* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		GtkLabel* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		GtkLabel* _tmp25_;
		GDateTime* _tmp26_;
		GDateTime* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* accessible_name = NULL;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		TweetListBox* _tmp33_;
		AtkObject* _tmp34_;
		const gchar* _tmp35_;
		TweetListBox* _tmp36_;
		AtkObject* _tmp37_;
		const gchar* _tmp38_;
#line 156 "../src/ListStatusesPage.vala"
		_tmp3_ = cb_bundle_get_string (args, LIST_STATUSES_PAGE_KEY_TITLE);
#line 156 "../src/ListStatusesPage.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 156 "../src/ListStatusesPage.vala"
		list_title = _tmp4_;
#line 157 "../src/ListStatusesPage.vala"
		user_list = cb_bundle_get_bool (args, LIST_STATUSES_PAGE_KEY_USER_LIST);
#line 158 "../src/ListStatusesPage.vala"
		_tmp5_ = cb_bundle_get_string (args, LIST_STATUSES_PAGE_KEY_DESCRIPTION);
#line 158 "../src/ListStatusesPage.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 158 "../src/ListStatusesPage.vala"
		description = _tmp6_;
#line 159 "../src/ListStatusesPage.vala"
		_tmp7_ = cb_bundle_get_string (args, LIST_STATUSES_PAGE_KEY_CREATOR);
#line 159 "../src/ListStatusesPage.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 159 "../src/ListStatusesPage.vala"
		creator = _tmp8_;
#line 160 "../src/ListStatusesPage.vala"
		n_subscribers = cb_bundle_get_int (args, LIST_STATUSES_PAGE_KEY_N_SUBSCRIBERS);
#line 161 "../src/ListStatusesPage.vala"
		n_members = cb_bundle_get_int (args, LIST_STATUSES_PAGE_KEY_N_MEMBERS);
#line 162 "../src/ListStatusesPage.vala"
		created_at = cb_bundle_get_int64 (args, LIST_STATUSES_PAGE_KEY_CREATED_AT);
#line 163 "../src/ListStatusesPage.vala"
		_tmp9_ = cb_bundle_get_string (args, LIST_STATUSES_PAGE_KEY_MODE);
#line 163 "../src/ListStatusesPage.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 163 "../src/ListStatusesPage.vala"
		mode = _tmp10_;
#line 165 "../src/ListStatusesPage.vala"
		_tmp11_ = self->priv->delete_button;
#line 165 "../src/ListStatusesPage.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, user_list);
#line 166 "../src/ListStatusesPage.vala"
		_tmp12_ = self->priv->edit_button;
#line 166 "../src/ListStatusesPage.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, user_list);
#line 167 "../src/ListStatusesPage.vala"
		_tmp13_ = self->priv->title_label;
#line 167 "../src/ListStatusesPage.vala"
		_tmp14_ = list_title;
#line 167 "../src/ListStatusesPage.vala"
		gtk_label_set_label (_tmp13_, _tmp14_);
#line 168 "../src/ListStatusesPage.vala"
		_tmp15_ = self->priv->description_label;
#line 168 "../src/ListStatusesPage.vala"
		_tmp16_ = description;
#line 168 "../src/ListStatusesPage.vala"
		gtk_label_set_label (_tmp15_, _tmp16_);
#line 169 "../src/ListStatusesPage.vala"
		_tmp17_ = self->priv->creator_label;
#line 169 "../src/ListStatusesPage.vala"
		_tmp18_ = creator;
#line 169 "../src/ListStatusesPage.vala"
		gtk_label_set_label (_tmp17_, _tmp18_);
#line 170 "../src/ListStatusesPage.vala"
		_tmp19_ = self->priv->members_label;
#line 170 "../src/ListStatusesPage.vala"
		_tmp20_ = g_strdup_printf ("%'d", n_members);
#line 170 "../src/ListStatusesPage.vala"
		_tmp21_ = _tmp20_;
#line 170 "../src/ListStatusesPage.vala"
		gtk_label_set_label (_tmp19_, _tmp21_);
#line 170 "../src/ListStatusesPage.vala"
		_g_free0 (_tmp21_);
#line 171 "../src/ListStatusesPage.vala"
		_tmp22_ = self->priv->subscribers_label;
#line 171 "../src/ListStatusesPage.vala"
		_tmp23_ = g_strdup_printf ("%'d", n_subscribers);
#line 171 "../src/ListStatusesPage.vala"
		_tmp24_ = _tmp23_;
#line 171 "../src/ListStatusesPage.vala"
		gtk_label_set_label (_tmp22_, _tmp24_);
#line 171 "../src/ListStatusesPage.vala"
		_g_free0 (_tmp24_);
#line 172 "../src/ListStatusesPage.vala"
		_tmp25_ = self->priv->created_at_label;
#line 172 "../src/ListStatusesPage.vala"
		_tmp26_ = g_date_time_new_from_unix_local (created_at);
#line 172 "../src/ListStatusesPage.vala"
		_tmp27_ = _tmp26_;
#line 172 "../src/ListStatusesPage.vala"
		_tmp28_ = g_date_time_format (_tmp27_, "%x, %X");
#line 172 "../src/ListStatusesPage.vala"
		_tmp29_ = _tmp28_;
#line 172 "../src/ListStatusesPage.vala"
		gtk_label_set_label (_tmp25_, _tmp29_);
#line 172 "../src/ListStatusesPage.vala"
		_g_free0 (_tmp29_);
#line 172 "../src/ListStatusesPage.vala"
		_g_date_time_unref0 (_tmp27_);
#line 173 "../src/ListStatusesPage.vala"
		_tmp30_ = mode;
#line 173 "../src/ListStatusesPage.vala"
		list_statuses_page_set_mode_label (self, _tmp30_);
#line 176 "../src/ListStatusesPage.vala"
		_tmp31_ = list_title;
#line 176 "../src/ListStatusesPage.vala"
		_tmp32_ = g_strdup_printf (_ ("%s list tweets"), _tmp31_);
#line 176 "../src/ListStatusesPage.vala"
		accessible_name = _tmp32_;
#line 177 "../src/ListStatusesPage.vala"
		_tmp33_ = self->priv->tweet_list;
#line 177 "../src/ListStatusesPage.vala"
		_tmp34_ = gtk_widget_get_accessible ((GtkWidget*) _tmp33_);
#line 177 "../src/ListStatusesPage.vala"
		_tmp35_ = accessible_name;
#line 177 "../src/ListStatusesPage.vala"
		atk_object_set_name (_tmp34_, _tmp35_);
#line 178 "../src/ListStatusesPage.vala"
		_tmp36_ = self->priv->tweet_list;
#line 178 "../src/ListStatusesPage.vala"
		_tmp37_ = gtk_widget_get_accessible ((GtkWidget*) _tmp36_);
#line 178 "../src/ListStatusesPage.vala"
		_tmp38_ = accessible_name;
#line 178 "../src/ListStatusesPage.vala"
		atk_object_set_description (_tmp37_, _tmp38_);
#line 155 "../src/ListStatusesPage.vala"
		_g_free0 (accessible_name);
#line 155 "../src/ListStatusesPage.vala"
		_g_free0 (mode);
#line 155 "../src/ListStatusesPage.vala"
		_g_free0 (creator);
#line 155 "../src/ListStatusesPage.vala"
		_g_free0 (description);
#line 155 "../src/ListStatusesPage.vala"
		_g_free0 (list_title);
#line 892 "ListStatusesPage.c"
	}
#line 181 "../src/ListStatusesPage.vala"
	_tmp39_ = g_strdup_printf ("%" G_GINT64_FORMAT, list_id);
#line 181 "../src/ListStatusesPage.vala"
	_tmp40_ = _tmp39_;
#line 181 "../src/ListStatusesPage.vala"
	_tmp41_ = g_strconcat ("Showing list with id ", _tmp40_, NULL);
#line 181 "../src/ListStatusesPage.vala"
	_tmp42_ = _tmp41_;
#line 181 "../src/ListStatusesPage.vala"
	g_debug ("ListStatusesPage.vala:181: %s", _tmp42_);
#line 181 "../src/ListStatusesPage.vala"
	_g_free0 (_tmp42_);
#line 181 "../src/ListStatusesPage.vala"
	_g_free0 (_tmp40_);
#line 182 "../src/ListStatusesPage.vala"
	if (list_id == self->priv->list_id) {
#line 183 "../src/ListStatusesPage.vala"
		self->priv->list_id = list_id;
#line 184 "../src/ListStatusesPage.vala"
		list_statuses_page_load_newer (self, NULL, NULL);
#line 914 "ListStatusesPage.c"
	} else {
		TweetListBox* _tmp43_;
		CbTweetModel* _tmp44_;
#line 186 "../src/ListStatusesPage.vala"
		self->priv->list_id = list_id;
#line 187 "../src/ListStatusesPage.vala"
		_tmp43_ = self->priv->tweet_list;
#line 187 "../src/ListStatusesPage.vala"
		_tmp44_ = _tmp43_->model;
#line 187 "../src/ListStatusesPage.vala"
		cb_tweet_model_clear (_tmp44_);
#line 188 "../src/ListStatusesPage.vala"
		list_statuses_page_load_newest (self, NULL, NULL);
#line 928 "ListStatusesPage.c"
	}
#line 146 "../src/ListStatusesPage.vala"
	_g_free0 (list_name);
#line 932 "ListStatusesPage.c"
}

static void
list_statuses_page_real_on_leave (IPage* base)
{
	ListStatusesPage * self;
#line 193 "../src/ListStatusesPage.vala"
	self = (ListStatusesPage*) base;
#line 941 "ListStatusesPage.c"
}

static void
list_statuses_page_load_newest_data_free (gpointer _data)
{
	ListStatusesPageLoadNewestData* _data_;
	_data_ = _data;
#line 19 "../src/ListStatusesPage.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/ListStatusesPage.vala"
	g_slice_free (ListStatusesPageLoadNewestData, _data_);
#line 953 "ListStatusesPage.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 19 "../src/ListStatusesPage.vala"
	return self ? g_object_ref (self) : NULL;
#line 961 "ListStatusesPage.c"
}

static void
list_statuses_page_load_newest (ListStatusesPage* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	ListStatusesPageLoadNewestData* _data_;
	ListStatusesPage* _tmp0_;
#line 19 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/ListStatusesPage.vala"
	_data_ = g_slice_new0 (ListStatusesPageLoadNewestData);
#line 19 "../src/ListStatusesPage.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/ListStatusesPage.vala"
	g_task_set_task_data (_data_->_async_result, _data_, list_statuses_page_load_newest_data_free);
#line 19 "../src/ListStatusesPage.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/ListStatusesPage.vala"
	_data_->self = _tmp0_;
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_load_newest_co (_data_);
#line 985 "ListStatusesPage.c"
}

static void
list_statuses_page_load_newest_finish (ListStatusesPage* self,
                                       GAsyncResult* _res_)
{
	ListStatusesPageLoadNewestData* _data_;
#line 19 "../src/ListStatusesPage.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 995 "ListStatusesPage.c"
}

static void
list_statuses_page_load_newest_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	ListStatusesPageLoadNewestData* _data_;
#line 210 "../src/ListStatusesPage.vala"
	_data_ = _user_data_;
#line 210 "../src/ListStatusesPage.vala"
	_data_->_source_object_ = source_object;
#line 210 "../src/ListStatusesPage.vala"
	_data_->_res_ = _res_;
#line 210 "../src/ListStatusesPage.vala"
	list_statuses_page_load_newest_co (_data_);
#line 1012 "ListStatusesPage.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 210 "../src/ListStatusesPage.vala"
	g_boxed_free (json_node_get_type (), self);
#line 1020 "ListStatusesPage.c"
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 220 "../src/ListStatusesPage.vala"
	return self ? json_array_ref (self) : NULL;
#line 1028 "ListStatusesPage.c"
}

static gboolean
list_statuses_page_load_newest_co (ListStatusesPageLoadNewestData* _data_)
{
#line 195 "../src/ListStatusesPage.vala"
	switch (_data_->_state_) {
#line 195 "../src/ListStatusesPage.vala"
		case 0:
#line 1038 "ListStatusesPage.c"
		goto _state_0;
#line 195 "../src/ListStatusesPage.vala"
		case 1:
#line 1042 "ListStatusesPage.c"
		goto _state_1;
		default:
#line 195 "../src/ListStatusesPage.vala"
		g_assert_not_reached ();
#line 1047 "ListStatusesPage.c"
	}
	_state_0:
#line 196 "../src/ListStatusesPage.vala"
	_data_->self->priv->loading = TRUE;
#line 197 "../src/ListStatusesPage.vala"
	_data_->_tmp0_ = _data_->self->priv->tweet_list;
#line 197 "../src/ListStatusesPage.vala"
	list_box_set_unempty ((ListBox*) _data_->_tmp0_);
#line 198 "../src/ListStatusesPage.vala"
	_data_->requested_tweet_count = (guint) 25;
#line 199 "../src/ListStatusesPage.vala"
	_data_->_tmp1_ = _data_->self->account;
#line 199 "../src/ListStatusesPage.vala"
	_data_->_tmp2_ = _data_->_tmp1_->proxy;
#line 199 "../src/ListStatusesPage.vala"
	_data_->_tmp3_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp2_);
#line 199 "../src/ListStatusesPage.vala"
	_data_->call = _data_->_tmp3_;
#line 200 "../src/ListStatusesPage.vala"
	_data_->_tmp4_ = _data_->call;
#line 200 "../src/ListStatusesPage.vala"
	rest_proxy_call_set_function (_data_->_tmp4_, "1.1/lists/statuses.json");
#line 201 "../src/ListStatusesPage.vala"
	_data_->_tmp5_ = _data_->call;
#line 201 "../src/ListStatusesPage.vala"
	rest_proxy_call_set_method (_data_->_tmp5_, "GET");
#line 202 "../src/ListStatusesPage.vala"
	_data_->_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->self->priv->list_id);
#line 202 "../src/ListStatusesPage.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 202 "../src/ListStatusesPage.vala"
	g_debug ("ListStatusesPage.vala:202: USING LIST ID %s", _data_->_tmp7_);
#line 202 "../src/ListStatusesPage.vala"
	_g_free0 (_data_->_tmp7_);
#line 203 "../src/ListStatusesPage.vala"
	_data_->_tmp8_ = _data_->call;
#line 203 "../src/ListStatusesPage.vala"
	_data_->_tmp9_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->self->priv->list_id);
#line 203 "../src/ListStatusesPage.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 203 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp8_, "list_id", _data_->_tmp10_);
#line 203 "../src/ListStatusesPage.vala"
	_g_free0 (_data_->_tmp10_);
#line 204 "../src/ListStatusesPage.vala"
	_data_->_tmp11_ = _data_->call;
#line 204 "../src/ListStatusesPage.vala"
	_data_->_tmp12_ = g_strdup_printf ("%u", _data_->requested_tweet_count);
#line 204 "../src/ListStatusesPage.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 204 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp11_, "count", _data_->_tmp13_);
#line 204 "../src/ListStatusesPage.vala"
	_g_free0 (_data_->_tmp13_);
#line 205 "../src/ListStatusesPage.vala"
	_data_->_tmp14_ = _data_->call;
#line 205 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp14_, "tweet_mode", "extended");
#line 206 "../src/ListStatusesPage.vala"
	_data_->_tmp15_ = _data_->call;
#line 206 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp15_, "include_ext_alt_text", "true");
#line 208 "../src/ListStatusesPage.vala"
	_data_->root = NULL;
#line 1112 "ListStatusesPage.c"
	{
#line 210 "../src/ListStatusesPage.vala"
		_data_->_tmp17_ = _data_->call;
#line 210 "../src/ListStatusesPage.vala"
		_data_->_state_ = 1;
#line 210 "../src/ListStatusesPage.vala"
		cb_utils_load_threaded_async (_data_->_tmp17_, NULL, list_statuses_page_load_newest_ready, _data_);
#line 210 "../src/ListStatusesPage.vala"
		return FALSE;
#line 1122 "ListStatusesPage.c"
		_state_1:
#line 210 "../src/ListStatusesPage.vala"
		_data_->_tmp18_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
#line 210 "../src/ListStatusesPage.vala"
		_data_->_tmp16_ = _data_->_tmp18_;
#line 210 "../src/ListStatusesPage.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1130 "ListStatusesPage.c"
			goto __catch0_g_error;
		}
#line 210 "../src/ListStatusesPage.vala"
		_data_->_tmp19_ = _data_->_tmp16_;
#line 210 "../src/ListStatusesPage.vala"
		_data_->_tmp16_ = NULL;
#line 210 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 210 "../src/ListStatusesPage.vala"
		_data_->root = _data_->_tmp19_;
#line 209 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->_tmp16_);
#line 1143 "ListStatusesPage.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 209 "../src/ListStatusesPage.vala"
		_data_->e = _data_->_inner_error0_;
#line 209 "../src/ListStatusesPage.vala"
		_data_->_inner_error0_ = NULL;
#line 212 "../src/ListStatusesPage.vala"
		_data_->_tmp20_ = _data_->e;
#line 212 "../src/ListStatusesPage.vala"
		_data_->_tmp21_ = _data_->_tmp20_->message;
#line 212 "../src/ListStatusesPage.vala"
		_data_->_tmp22_ = g_utf8_strdown (_data_->_tmp21_, (gssize) -1);
#line 212 "../src/ListStatusesPage.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 212 "../src/ListStatusesPage.vala"
		_data_->_tmp24_ = g_strcmp0 (_data_->_tmp23_, "not found") == 0;
#line 212 "../src/ListStatusesPage.vala"
		_g_free0 (_data_->_tmp23_);
#line 212 "../src/ListStatusesPage.vala"
		if (_data_->_tmp24_) {
#line 213 "../src/ListStatusesPage.vala"
			_data_->_tmp25_ = _data_->self->priv->tweet_list;
#line 213 "../src/ListStatusesPage.vala"
			list_box_set_empty ((ListBox*) _data_->_tmp25_);
#line 1170 "ListStatusesPage.c"
		}
#line 215 "../src/ListStatusesPage.vala"
		_data_->_tmp26_ = _data_->e;
#line 215 "../src/ListStatusesPage.vala"
		_data_->_tmp27_ = _data_->_tmp26_->message;
#line 215 "../src/ListStatusesPage.vala"
		g_warning ("ListStatusesPage.vala:215: %s", _data_->_tmp27_);
#line 216 "../src/ListStatusesPage.vala"
		_data_->self->priv->loading = FALSE;
#line 217 "../src/ListStatusesPage.vala"
		_g_error_free0 (_data_->e);
#line 217 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 217 "../src/ListStatusesPage.vala"
		_g_object_unref0 (_data_->call);
#line 217 "../src/ListStatusesPage.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 217 "../src/ListStatusesPage.vala"
		if (_data_->_state_ != 0) {
#line 217 "../src/ListStatusesPage.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 217 "../src/ListStatusesPage.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1194 "ListStatusesPage.c"
			}
		}
#line 217 "../src/ListStatusesPage.vala"
		g_object_unref (_data_->_async_result);
#line 217 "../src/ListStatusesPage.vala"
		return FALSE;
#line 1201 "ListStatusesPage.c"
	}
	__finally0:
#line 209 "../src/ListStatusesPage.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 209 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 209 "../src/ListStatusesPage.vala"
		_g_object_unref0 (_data_->call);
#line 209 "../src/ListStatusesPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 209 "../src/ListStatusesPage.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 209 "../src/ListStatusesPage.vala"
		g_object_unref (_data_->_async_result);
#line 209 "../src/ListStatusesPage.vala"
		return FALSE;
#line 1218 "ListStatusesPage.c"
	}
#line 220 "../src/ListStatusesPage.vala"
	_data_->_tmp28_ = _data_->root;
#line 220 "../src/ListStatusesPage.vala"
	_data_->_tmp29_ = json_node_get_array (_data_->_tmp28_);
#line 220 "../src/ListStatusesPage.vala"
	_data_->_tmp30_ = _json_array_ref0 (_data_->_tmp29_);
#line 220 "../src/ListStatusesPage.vala"
	_data_->root_array = _data_->_tmp30_;
#line 221 "../src/ListStatusesPage.vala"
	_data_->_tmp31_ = _data_->root_array;
#line 221 "../src/ListStatusesPage.vala"
	if (json_array_get_length (_data_->_tmp31_) == ((guint) 0)) {
#line 222 "../src/ListStatusesPage.vala"
		_data_->_tmp32_ = _data_->self->priv->tweet_list;
#line 222 "../src/ListStatusesPage.vala"
		list_box_set_empty ((ListBox*) _data_->_tmp32_);
#line 223 "../src/ListStatusesPage.vala"
		_data_->self->priv->loading = FALSE;
#line 224 "../src/ListStatusesPage.vala"
		_json_array_unref0 (_data_->root_array);
#line 224 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 224 "../src/ListStatusesPage.vala"
		_g_object_unref0 (_data_->call);
#line 224 "../src/ListStatusesPage.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 224 "../src/ListStatusesPage.vala"
		if (_data_->_state_ != 0) {
#line 224 "../src/ListStatusesPage.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 224 "../src/ListStatusesPage.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1252 "ListStatusesPage.c"
			}
		}
#line 224 "../src/ListStatusesPage.vala"
		g_object_unref (_data_->_async_result);
#line 224 "../src/ListStatusesPage.vala"
		return FALSE;
#line 1259 "ListStatusesPage.c"
	}
#line 226 "../src/ListStatusesPage.vala"
	_data_->_tmp33_ = _data_->root_array;
#line 226 "../src/ListStatusesPage.vala"
	_data_->_tmp34_ = _data_->self->priv->tweet_list;
#line 226 "../src/ListStatusesPage.vala"
	_data_->_tmp35_ = _data_->self->account;
#line 226 "../src/ListStatusesPage.vala"
	tweet_utils_work_array (_data_->_tmp33_, _data_->_tmp34_, _data_->_tmp35_);
#line 230 "../src/ListStatusesPage.vala"
	_data_->self->priv->loading = FALSE;
#line 195 "../src/ListStatusesPage.vala"
	_json_array_unref0 (_data_->root_array);
#line 195 "../src/ListStatusesPage.vala"
	__vala_JsonNode_free0 (_data_->root);
#line 195 "../src/ListStatusesPage.vala"
	_g_object_unref0 (_data_->call);
#line 195 "../src/ListStatusesPage.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 195 "../src/ListStatusesPage.vala"
	if (_data_->_state_ != 0) {
#line 195 "../src/ListStatusesPage.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 195 "../src/ListStatusesPage.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1285 "ListStatusesPage.c"
		}
	}
#line 195 "../src/ListStatusesPage.vala"
	g_object_unref (_data_->_async_result);
#line 195 "../src/ListStatusesPage.vala"
	return FALSE;
#line 1292 "ListStatusesPage.c"
}

static void
list_statuses_page_load_older_data_free (gpointer _data)
{
	ListStatusesPageLoadOlderData* _data_;
	_data_ = _data;
#line 19 "../src/ListStatusesPage.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/ListStatusesPage.vala"
	g_slice_free (ListStatusesPageLoadOlderData, _data_);
#line 1304 "ListStatusesPage.c"
}

static void
list_statuses_page_load_older (ListStatusesPage* self,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ListStatusesPageLoadOlderData* _data_;
	ListStatusesPage* _tmp0_;
#line 19 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/ListStatusesPage.vala"
	_data_ = g_slice_new0 (ListStatusesPageLoadOlderData);
#line 19 "../src/ListStatusesPage.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/ListStatusesPage.vala"
	g_task_set_task_data (_data_->_async_result, _data_, list_statuses_page_load_older_data_free);
#line 19 "../src/ListStatusesPage.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/ListStatusesPage.vala"
	_data_->self = _tmp0_;
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_load_older_co (_data_);
#line 1328 "ListStatusesPage.c"
}

static void
list_statuses_page_load_older_finish (ListStatusesPage* self,
                                      GAsyncResult* _res_)
{
	ListStatusesPageLoadOlderData* _data_;
#line 19 "../src/ListStatusesPage.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1338 "ListStatusesPage.c"
}

static void
list_statuses_page_load_older_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	ListStatusesPageLoadOlderData* _data_;
#line 250 "../src/ListStatusesPage.vala"
	_data_ = _user_data_;
#line 250 "../src/ListStatusesPage.vala"
	_data_->_source_object_ = source_object;
#line 250 "../src/ListStatusesPage.vala"
	_data_->_res_ = _res_;
#line 250 "../src/ListStatusesPage.vala"
	list_statuses_page_load_older_co (_data_);
#line 1355 "ListStatusesPage.c"
}

static gboolean
list_statuses_page_load_older_co (ListStatusesPageLoadOlderData* _data_)
{
#line 233 "../src/ListStatusesPage.vala"
	switch (_data_->_state_) {
#line 233 "../src/ListStatusesPage.vala"
		case 0:
#line 1365 "ListStatusesPage.c"
		goto _state_0;
#line 233 "../src/ListStatusesPage.vala"
		case 1:
#line 1369 "ListStatusesPage.c"
		goto _state_1;
		default:
#line 233 "../src/ListStatusesPage.vala"
		g_assert_not_reached ();
#line 1374 "ListStatusesPage.c"
	}
	_state_0:
#line 234 "../src/ListStatusesPage.vala"
	if (_data_->self->priv->loading) {
#line 235 "../src/ListStatusesPage.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 235 "../src/ListStatusesPage.vala"
		if (_data_->_state_ != 0) {
#line 235 "../src/ListStatusesPage.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 235 "../src/ListStatusesPage.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1387 "ListStatusesPage.c"
			}
		}
#line 235 "../src/ListStatusesPage.vala"
		g_object_unref (_data_->_async_result);
#line 235 "../src/ListStatusesPage.vala"
		return FALSE;
#line 1394 "ListStatusesPage.c"
	}
#line 237 "../src/ListStatusesPage.vala"
	_data_->self->priv->loading = TRUE;
#line 238 "../src/ListStatusesPage.vala"
	_data_->requested_tweet_count = (guint) 25;
#line 239 "../src/ListStatusesPage.vala"
	_data_->_tmp0_ = _data_->self->account;
#line 239 "../src/ListStatusesPage.vala"
	_data_->_tmp1_ = _data_->_tmp0_->proxy;
#line 239 "../src/ListStatusesPage.vala"
	_data_->_tmp2_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp1_);
#line 239 "../src/ListStatusesPage.vala"
	_data_->call = _data_->_tmp2_;
#line 240 "../src/ListStatusesPage.vala"
	_data_->_tmp3_ = _data_->call;
#line 240 "../src/ListStatusesPage.vala"
	rest_proxy_call_set_function (_data_->_tmp3_, "1.1/lists/statuses.json");
#line 241 "../src/ListStatusesPage.vala"
	_data_->_tmp4_ = _data_->call;
#line 241 "../src/ListStatusesPage.vala"
	rest_proxy_call_set_method (_data_->_tmp4_, "GET");
#line 242 "../src/ListStatusesPage.vala"
	_data_->_tmp5_ = _data_->call;
#line 242 "../src/ListStatusesPage.vala"
	_data_->_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->self->priv->list_id);
#line 242 "../src/ListStatusesPage.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 242 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp5_, "list_id", _data_->_tmp7_);
#line 242 "../src/ListStatusesPage.vala"
	_g_free0 (_data_->_tmp7_);
#line 243 "../src/ListStatusesPage.vala"
	_data_->_tmp8_ = _data_->call;
#line 243 "../src/ListStatusesPage.vala"
	_data_->_tmp9_ = _data_->self->priv->tweet_list;
#line 243 "../src/ListStatusesPage.vala"
	_data_->_tmp10_ = _data_->_tmp9_->model;
#line 243 "../src/ListStatusesPage.vala"
	_data_->_tmp11_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp10_->min_id - 1);
#line 243 "../src/ListStatusesPage.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 243 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp8_, "max_id", _data_->_tmp12_);
#line 243 "../src/ListStatusesPage.vala"
	_g_free0 (_data_->_tmp12_);
#line 244 "../src/ListStatusesPage.vala"
	_data_->_tmp13_ = _data_->call;
#line 244 "../src/ListStatusesPage.vala"
	_data_->_tmp14_ = g_strdup_printf ("%u", _data_->requested_tweet_count);
#line 244 "../src/ListStatusesPage.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 244 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp13_, "count", _data_->_tmp15_);
#line 244 "../src/ListStatusesPage.vala"
	_g_free0 (_data_->_tmp15_);
#line 245 "../src/ListStatusesPage.vala"
	_data_->_tmp16_ = _data_->call;
#line 245 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp16_, "tweet_mode", "extended");
#line 246 "../src/ListStatusesPage.vala"
	_data_->_tmp17_ = _data_->call;
#line 246 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp17_, "include_ext_alt_text", "true");
#line 248 "../src/ListStatusesPage.vala"
	_data_->root = NULL;
#line 1460 "ListStatusesPage.c"
	{
#line 250 "../src/ListStatusesPage.vala"
		_data_->_tmp19_ = _data_->call;
#line 250 "../src/ListStatusesPage.vala"
		_data_->_state_ = 1;
#line 250 "../src/ListStatusesPage.vala"
		cb_utils_load_threaded_async (_data_->_tmp19_, NULL, list_statuses_page_load_older_ready, _data_);
#line 250 "../src/ListStatusesPage.vala"
		return FALSE;
#line 1470 "ListStatusesPage.c"
		_state_1:
#line 250 "../src/ListStatusesPage.vala"
		_data_->_tmp20_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
#line 250 "../src/ListStatusesPage.vala"
		_data_->_tmp18_ = _data_->_tmp20_;
#line 250 "../src/ListStatusesPage.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1478 "ListStatusesPage.c"
			goto __catch0_g_error;
		}
#line 250 "../src/ListStatusesPage.vala"
		_data_->_tmp21_ = _data_->_tmp18_;
#line 250 "../src/ListStatusesPage.vala"
		_data_->_tmp18_ = NULL;
#line 250 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 250 "../src/ListStatusesPage.vala"
		_data_->root = _data_->_tmp21_;
#line 249 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->_tmp18_);
#line 1491 "ListStatusesPage.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 249 "../src/ListStatusesPage.vala"
		_data_->e = _data_->_inner_error0_;
#line 249 "../src/ListStatusesPage.vala"
		_data_->_inner_error0_ = NULL;
#line 252 "../src/ListStatusesPage.vala"
		_data_->_tmp22_ = _data_->e;
#line 252 "../src/ListStatusesPage.vala"
		_data_->_tmp23_ = _data_->_tmp22_->message;
#line 252 "../src/ListStatusesPage.vala"
		g_warning ("ListStatusesPage.vala:252: %s", _data_->_tmp23_);
#line 253 "../src/ListStatusesPage.vala"
		_g_error_free0 (_data_->e);
#line 253 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 253 "../src/ListStatusesPage.vala"
		_g_object_unref0 (_data_->call);
#line 253 "../src/ListStatusesPage.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 253 "../src/ListStatusesPage.vala"
		if (_data_->_state_ != 0) {
#line 253 "../src/ListStatusesPage.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 253 "../src/ListStatusesPage.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1520 "ListStatusesPage.c"
			}
		}
#line 253 "../src/ListStatusesPage.vala"
		g_object_unref (_data_->_async_result);
#line 253 "../src/ListStatusesPage.vala"
		return FALSE;
#line 1527 "ListStatusesPage.c"
	}
	__finally0:
#line 249 "../src/ListStatusesPage.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 249 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 249 "../src/ListStatusesPage.vala"
		_g_object_unref0 (_data_->call);
#line 249 "../src/ListStatusesPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 249 "../src/ListStatusesPage.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 249 "../src/ListStatusesPage.vala"
		g_object_unref (_data_->_async_result);
#line 249 "../src/ListStatusesPage.vala"
		return FALSE;
#line 1544 "ListStatusesPage.c"
	}
#line 256 "../src/ListStatusesPage.vala"
	_data_->_tmp24_ = _data_->root;
#line 256 "../src/ListStatusesPage.vala"
	_data_->_tmp25_ = json_node_get_array (_data_->_tmp24_);
#line 256 "../src/ListStatusesPage.vala"
	_data_->_tmp26_ = _json_array_ref0 (_data_->_tmp25_);
#line 256 "../src/ListStatusesPage.vala"
	_data_->root_array = _data_->_tmp26_;
#line 257 "../src/ListStatusesPage.vala"
	_data_->_tmp27_ = _data_->root_array;
#line 257 "../src/ListStatusesPage.vala"
	_data_->_tmp28_ = _data_->self->priv->tweet_list;
#line 257 "../src/ListStatusesPage.vala"
	_data_->_tmp29_ = _data_->self->account;
#line 257 "../src/ListStatusesPage.vala"
	tweet_utils_work_array (_data_->_tmp27_, _data_->_tmp28_, _data_->_tmp29_);
#line 260 "../src/ListStatusesPage.vala"
	_data_->self->priv->loading = FALSE;
#line 233 "../src/ListStatusesPage.vala"
	_json_array_unref0 (_data_->root_array);
#line 233 "../src/ListStatusesPage.vala"
	__vala_JsonNode_free0 (_data_->root);
#line 233 "../src/ListStatusesPage.vala"
	_g_object_unref0 (_data_->call);
#line 233 "../src/ListStatusesPage.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 233 "../src/ListStatusesPage.vala"
	if (_data_->_state_ != 0) {
#line 233 "../src/ListStatusesPage.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 233 "../src/ListStatusesPage.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1578 "ListStatusesPage.c"
		}
	}
#line 233 "../src/ListStatusesPage.vala"
	g_object_unref (_data_->_async_result);
#line 233 "../src/ListStatusesPage.vala"
	return FALSE;
#line 1585 "ListStatusesPage.c"
}

static void
list_statuses_page_set_mode_label (ListStatusesPage* self,
                                   const gchar* mode)
{
	const gchar* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
#line 263 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/ListStatusesPage.vala"
	g_return_if_fail (mode != NULL);
#line 264 "../src/ListStatusesPage.vala"
	if (g_strcmp0 (mode, "private") == 0) {
#line 264 "../src/ListStatusesPage.vala"
		_tmp0_ = _ ("Private");
#line 1602 "ListStatusesPage.c"
	} else {
#line 264 "../src/ListStatusesPage.vala"
		_tmp0_ = _ ("Public");
#line 1606 "ListStatusesPage.c"
	}
#line 264 "../src/ListStatusesPage.vala"
	_tmp1_ = self->priv->mode_label;
#line 264 "../src/ListStatusesPage.vala"
	gtk_label_set_label (_tmp1_, _tmp0_);
#line 1612 "ListStatusesPage.c"
}

static void
list_statuses_page_edit_button_clicked_cb (ListStatusesPage* self)
{
	GtkStack* _tmp0_;
	GtkEntry* _tmp1_;
	GtkStack* _tmp2_;
	GtkEntry* _tmp3_;
	GtkStack* _tmp4_;
	GtkButton* _tmp5_;
	GtkStack* _tmp6_;
	GtkButton* _tmp7_;
	GtkStack* _tmp8_;
	GtkComboBoxText* _tmp9_;
	GtkEntry* _tmp10_;
	GtkLabel* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GtkEntry* _tmp14_;
	GtkLabel* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_ = NULL;
	GtkLabel* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GtkComboBoxText* _tmp22_;
#line 268 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->title_stack;
#line 269 "../src/ListStatusesPage.vala"
	_tmp1_ = self->priv->title_entry;
#line 269 "../src/ListStatusesPage.vala"
	gtk_stack_set_visible_child (_tmp0_, (GtkWidget*) _tmp1_);
#line 270 "../src/ListStatusesPage.vala"
	_tmp2_ = self->priv->description_stack;
#line 270 "../src/ListStatusesPage.vala"
	_tmp3_ = self->priv->description_entry;
#line 270 "../src/ListStatusesPage.vala"
	gtk_stack_set_visible_child (_tmp2_, (GtkWidget*) _tmp3_);
#line 271 "../src/ListStatusesPage.vala"
	_tmp4_ = self->priv->delete_stack;
#line 271 "../src/ListStatusesPage.vala"
	_tmp5_ = self->priv->cancel_button;
#line 271 "../src/ListStatusesPage.vala"
	gtk_stack_set_visible_child (_tmp4_, (GtkWidget*) _tmp5_);
#line 272 "../src/ListStatusesPage.vala"
	_tmp6_ = self->priv->edit_stack;
#line 272 "../src/ListStatusesPage.vala"
	_tmp7_ = self->priv->save_button;
#line 272 "../src/ListStatusesPage.vala"
	gtk_stack_set_visible_child (_tmp6_, (GtkWidget*) _tmp7_);
#line 273 "../src/ListStatusesPage.vala"
	_tmp8_ = self->priv->mode_stack;
#line 273 "../src/ListStatusesPage.vala"
	_tmp9_ = self->priv->mode_combo_box;
#line 273 "../src/ListStatusesPage.vala"
	gtk_stack_set_visible_child (_tmp8_, (GtkWidget*) _tmp9_);
#line 275 "../src/ListStatusesPage.vala"
	_tmp10_ = self->priv->title_entry;
#line 275 "../src/ListStatusesPage.vala"
	_tmp11_ = self->priv->title_label;
#line 275 "../src/ListStatusesPage.vala"
	_tmp12_ = gtk_label_get_label (_tmp11_);
#line 275 "../src/ListStatusesPage.vala"
	_tmp13_ = _tmp12_;
#line 275 "../src/ListStatusesPage.vala"
	gtk_entry_set_text (_tmp10_, _tmp13_);
#line 276 "../src/ListStatusesPage.vala"
	_tmp14_ = self->priv->description_entry;
#line 276 "../src/ListStatusesPage.vala"
	_tmp15_ = self->priv->description_label;
#line 276 "../src/ListStatusesPage.vala"
	_tmp16_ = gtk_label_get_label (_tmp15_);
#line 276 "../src/ListStatusesPage.vala"
	_tmp17_ = _tmp16_;
#line 276 "../src/ListStatusesPage.vala"
	gtk_entry_set_text (_tmp14_, _tmp17_);
#line 277 "../src/ListStatusesPage.vala"
	_tmp19_ = self->priv->mode_label;
#line 277 "../src/ListStatusesPage.vala"
	_tmp20_ = gtk_label_get_label (_tmp19_);
#line 277 "../src/ListStatusesPage.vala"
	_tmp21_ = _tmp20_;
#line 277 "../src/ListStatusesPage.vala"
	if (g_strcmp0 (_tmp21_, _ ("Private")) == 0) {
#line 277 "../src/ListStatusesPage.vala"
		_tmp18_ = "private";
#line 1703 "ListStatusesPage.c"
	} else {
#line 277 "../src/ListStatusesPage.vala"
		_tmp18_ = "public";
#line 1707 "ListStatusesPage.c"
	}
#line 277 "../src/ListStatusesPage.vala"
	_tmp22_ = self->priv->mode_combo_box;
#line 277 "../src/ListStatusesPage.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp22_, _tmp18_);
#line 1713 "ListStatusesPage.c"
}

static void
_list_statuses_page_edit_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_edit_button_clicked_cb ((ListStatusesPage*) self);
#line 1722 "ListStatusesPage.c"
}

static void
list_statuses_page_cancel_button_clicked_cb (ListStatusesPage* self)
{
	GtkStack* _tmp0_;
	GtkLabel* _tmp1_;
	GtkStack* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStack* _tmp4_;
	GtkMenuButton* _tmp5_;
	GtkStack* _tmp6_;
	GtkButton* _tmp7_;
	GtkStack* _tmp8_;
	GtkLabel* _tmp9_;
#line 281 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->title_stack;
#line 282 "../src/ListStatusesPage.vala"
	_tmp1_ = self->priv->title_label;
#line 282 "../src/ListStatusesPage.vala"
	gtk_stack_set_visible_child (_tmp0_, (GtkWidget*) _tmp1_);
#line 283 "../src/ListStatusesPage.vala"
	_tmp2_ = self->priv->description_stack;
#line 283 "../src/ListStatusesPage.vala"
	_tmp3_ = self->priv->description_label;
#line 283 "../src/ListStatusesPage.vala"
	gtk_stack_set_visible_child (_tmp2_, (GtkWidget*) _tmp3_);
#line 284 "../src/ListStatusesPage.vala"
	_tmp4_ = self->priv->delete_stack;
#line 284 "../src/ListStatusesPage.vala"
	_tmp5_ = self->priv->delete_button;
#line 284 "../src/ListStatusesPage.vala"
	gtk_stack_set_visible_child (_tmp4_, (GtkWidget*) _tmp5_);
#line 285 "../src/ListStatusesPage.vala"
	_tmp6_ = self->priv->edit_stack;
#line 285 "../src/ListStatusesPage.vala"
	_tmp7_ = self->priv->edit_button;
#line 285 "../src/ListStatusesPage.vala"
	gtk_stack_set_visible_child (_tmp6_, (GtkWidget*) _tmp7_);
#line 286 "../src/ListStatusesPage.vala"
	_tmp8_ = self->priv->mode_stack;
#line 286 "../src/ListStatusesPage.vala"
	_tmp9_ = self->priv->mode_label;
#line 286 "../src/ListStatusesPage.vala"
	gtk_stack_set_visible_child (_tmp8_, (GtkWidget*) _tmp9_);
#line 1770 "ListStatusesPage.c"
}

static void
_list_statuses_page_cancel_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self)
{
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_cancel_button_clicked_cb ((ListStatusesPage*) self);
#line 1779 "ListStatusesPage.c"
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 290 "../src/ListStatusesPage.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 290 "../src/ListStatusesPage.vala"
	return _data25_;
#line 1789 "ListStatusesPage.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 290 "../src/ListStatusesPage.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 1799 "ListStatusesPage.c"
		ListStatusesPage* self;
#line 290 "../src/ListStatusesPage.vala"
		self = _data25_->self;
#line 290 "../src/ListStatusesPage.vala"
		_g_object_unref0 (_data25_->call);
#line 290 "../src/ListStatusesPage.vala"
		_g_object_unref0 (self);
#line 290 "../src/ListStatusesPage.vala"
		g_slice_free (Block25Data, _data25_);
#line 1809 "ListStatusesPage.c"
	}
}

static void
__lambda105_ (Block25Data* _data25_,
              GObject* o,
              GAsyncResult* res)
{
	ListStatusesPage* self;
	Account* _tmp4_;
	CbUserStream* _tmp5_;
	const gchar* _tmp6_;
	GtkButton* _tmp7_;
	GtkMenuButton* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 307 "../src/ListStatusesPage.vala"
	self = _data25_->self;
#line 307 "../src/ListStatusesPage.vala"
	g_return_if_fail (res != NULL);
#line 1829 "ListStatusesPage.c"
	{
#line 309 "../src/ListStatusesPage.vala"
		rest_proxy_call_invoke_finish (_data25_->call, res, &_inner_error0_);
#line 309 "../src/ListStatusesPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1835 "ListStatusesPage.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		GError* _tmp1_;
		GError* _tmp2_;
		MainWindow* _tmp3_;
#line 308 "../src/ListStatusesPage.vala"
		e = _inner_error0_;
#line 308 "../src/ListStatusesPage.vala"
		_inner_error0_ = NULL;
#line 311 "../src/ListStatusesPage.vala"
		_tmp0_ = e;
#line 311 "../src/ListStatusesPage.vala"
		_tmp1_ = tweet_utils_failed_request_to_error (_data25_->call, _tmp0_);
#line 311 "../src/ListStatusesPage.vala"
		_tmp2_ = _tmp1_;
#line 311 "../src/ListStatusesPage.vala"
		_tmp3_ = self->priv->main_window;
#line 311 "../src/ListStatusesPage.vala"
		utils_show_error_dialog (_tmp2_, (GtkWindow*) _tmp3_, NULL, 0);
#line 311 "../src/ListStatusesPage.vala"
		_g_error_free0 (_tmp2_);
#line 308 "../src/ListStatusesPage.vala"
		_g_error_free0 (e);
#line 1865 "ListStatusesPage.c"
	}
	__finally0:
#line 308 "../src/ListStatusesPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 308 "../src/ListStatusesPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 308 "../src/ListStatusesPage.vala"
		g_clear_error (&_inner_error0_);
#line 308 "../src/ListStatusesPage.vala"
		return;
#line 1876 "ListStatusesPage.c"
	}
#line 313 "../src/ListStatusesPage.vala"
	_tmp4_ = self->account;
#line 313 "../src/ListStatusesPage.vala"
	_tmp5_ = _tmp4_->user_stream;
#line 313 "../src/ListStatusesPage.vala"
	_tmp6_ = rest_proxy_call_get_payload (_data25_->call);
#line 313 "../src/ListStatusesPage.vala"
	cb_user_stream_inject_tweet (_tmp5_, CB_STREAM_MESSAGE_EVENT_LIST_UPDATED, _tmp6_);
#line 314 "../src/ListStatusesPage.vala"
	_tmp7_ = self->priv->edit_button;
#line 314 "../src/ListStatusesPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
#line 315 "../src/ListStatusesPage.vala"
	_tmp8_ = self->priv->delete_button;
#line 315 "../src/ListStatusesPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, TRUE);
#line 1894 "ListStatusesPage.c"
}

static void
___lambda105__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 307 "../src/ListStatusesPage.vala"
	__lambda105_ (self, source_object, res);
#line 307 "../src/ListStatusesPage.vala"
	block25_data_unref (self);
#line 1906 "ListStatusesPage.c"
}

static void
list_statuses_page_save_button_clicked_cb (ListStatusesPage* self)
{
	Block25Data* _data25_;
	GtkLabel* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkComboBoxText* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GtkButton* _tmp10_;
	GtkMenuButton* _tmp11_;
	Account* _tmp12_;
	OAuthProxy* _tmp13_;
	RestProxyCall* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkLabel* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GtkComboBoxText* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GtkLabel* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	MainWindow* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
#line 290 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/ListStatusesPage.vala"
	_data25_ = g_slice_new0 (Block25Data);
#line 290 "../src/ListStatusesPage.vala"
	_data25_->_ref_count_ = 1;
#line 290 "../src/ListStatusesPage.vala"
	_data25_->self = g_object_ref (self);
#line 292 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->title_label;
#line 292 "../src/ListStatusesPage.vala"
	_tmp1_ = self->priv->title_entry;
#line 292 "../src/ListStatusesPage.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 292 "../src/ListStatusesPage.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 293 "../src/ListStatusesPage.vala"
	_tmp3_ = self->priv->description_label;
#line 293 "../src/ListStatusesPage.vala"
	_tmp4_ = self->priv->description_entry;
#line 293 "../src/ListStatusesPage.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 293 "../src/ListStatusesPage.vala"
	_tmp6_ = _tmp5_;
#line 293 "../src/ListStatusesPage.vala"
	gtk_label_set_label (_tmp3_, _tmp6_);
#line 294 "../src/ListStatusesPage.vala"
	_tmp7_ = self->priv->mode_combo_box;
#line 294 "../src/ListStatusesPage.vala"
	_tmp8_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp7_);
#line 294 "../src/ListStatusesPage.vala"
	_tmp9_ = _tmp8_;
#line 294 "../src/ListStatusesPage.vala"
	list_statuses_page_set_mode_label (self, _tmp9_);
#line 295 "../src/ListStatusesPage.vala"
	list_statuses_page_cancel_button_clicked_cb (self);
#line 296 "../src/ListStatusesPage.vala"
	_tmp10_ = self->priv->edit_button;
#line 296 "../src/ListStatusesPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
#line 297 "../src/ListStatusesPage.vala"
	_tmp11_ = self->priv->delete_button;
#line 297 "../src/ListStatusesPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
#line 298 "../src/ListStatusesPage.vala"
	_tmp12_ = self->account;
#line 298 "../src/ListStatusesPage.vala"
	_tmp13_ = _tmp12_->proxy;
#line 298 "../src/ListStatusesPage.vala"
	_tmp14_ = rest_proxy_new_call ((RestProxy*) _tmp13_);
#line 298 "../src/ListStatusesPage.vala"
	_data25_->call = _tmp14_;
#line 299 "../src/ListStatusesPage.vala"
	rest_proxy_call_set_function (_data25_->call, "1.1/lists/update.json");
#line 300 "../src/ListStatusesPage.vala"
	rest_proxy_call_set_method (_data25_->call, "POST");
#line 301 "../src/ListStatusesPage.vala"
	_tmp15_ = g_strdup_printf ("%" G_GINT64_FORMAT, self->priv->list_id);
#line 301 "../src/ListStatusesPage.vala"
	_tmp16_ = _tmp15_;
#line 301 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data25_->call, "list_id", _tmp16_);
#line 301 "../src/ListStatusesPage.vala"
	_g_free0 (_tmp16_);
#line 302 "../src/ListStatusesPage.vala"
	_tmp17_ = self->priv->title_label;
#line 302 "../src/ListStatusesPage.vala"
	_tmp18_ = gtk_label_get_label (_tmp17_);
#line 302 "../src/ListStatusesPage.vala"
	_tmp19_ = _tmp18_;
#line 302 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data25_->call, "name", _tmp19_);
#line 303 "../src/ListStatusesPage.vala"
	_tmp20_ = self->priv->mode_combo_box;
#line 303 "../src/ListStatusesPage.vala"
	_tmp21_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp20_);
#line 303 "../src/ListStatusesPage.vala"
	_tmp22_ = _tmp21_;
#line 303 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data25_->call, "mode", _tmp22_);
#line 304 "../src/ListStatusesPage.vala"
	_tmp23_ = self->priv->description_label;
#line 304 "../src/ListStatusesPage.vala"
	_tmp24_ = gtk_label_get_label (_tmp23_);
#line 304 "../src/ListStatusesPage.vala"
	_tmp25_ = _tmp24_;
#line 304 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data25_->call, "description", _tmp25_);
#line 305 "../src/ListStatusesPage.vala"
	_tmp26_ = self->priv->main_window;
#line 305 "../src/ListStatusesPage.vala"
	_tmp27_ = ipage_get_title ((IPage*) self);
#line 305 "../src/ListStatusesPage.vala"
	_tmp28_ = _tmp27_;
#line 305 "../src/ListStatusesPage.vala"
	main_window_set_window_title (_tmp26_, _tmp28_, GTK_STACK_TRANSITION_TYPE_NONE);
#line 305 "../src/ListStatusesPage.vala"
	_g_free0 (_tmp28_);
#line 307 "../src/ListStatusesPage.vala"
	rest_proxy_call_invoke_async (_data25_->call, NULL, ___lambda105__gasync_ready_callback, block25_data_ref (_data25_));
#line 290 "../src/ListStatusesPage.vala"
	block25_data_unref (_data25_);
#line 290 "../src/ListStatusesPage.vala"
	_data25_ = NULL;
#line 2046 "ListStatusesPage.c"
}

static void
_list_statuses_page_save_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_save_button_clicked_cb ((ListStatusesPage*) self);
#line 2055 "ListStatusesPage.c"
}

static void
__lambda106_ (ListStatusesPage* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 321 "../src/ListStatusesPage.vala"
	g_return_if_fail (res != NULL);
#line 2066 "ListStatusesPage.c"
	{
		CbBundle* bundle = NULL;
		CbBundle* _tmp0_;
		CbBundle* _tmp1_;
		CbBundle* _tmp2_;
		MainWindow* _tmp3_;
		MainWidget* _tmp4_;
		CbBundle* _tmp5_;
#line 323 "../src/ListStatusesPage.vala"
		list_utils_delete_list_finish (res, &_inner_error0_);
#line 323 "../src/ListStatusesPage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2079 "ListStatusesPage.c"
			goto __catch0_g_error;
		}
#line 325 "../src/ListStatusesPage.vala"
		_tmp0_ = cb_bundle_new ();
#line 325 "../src/ListStatusesPage.vala"
		bundle = _tmp0_;
#line 326 "../src/ListStatusesPage.vala"
		_tmp1_ = bundle;
#line 326 "../src/ListStatusesPage.vala"
		cb_bundle_put_int (_tmp1_, LISTS_PAGE_KEY_MODE, LISTS_PAGE_MODE_DELETE);
#line 327 "../src/ListStatusesPage.vala"
		_tmp2_ = bundle;
#line 327 "../src/ListStatusesPage.vala"
		cb_bundle_put_int64 (_tmp2_, LISTS_PAGE_KEY_LIST_ID, self->priv->list_id);
#line 328 "../src/ListStatusesPage.vala"
		_tmp3_ = self->priv->main_window;
#line 328 "../src/ListStatusesPage.vala"
		_tmp4_ = _tmp3_->main_widget;
#line 328 "../src/ListStatusesPage.vala"
		_tmp5_ = bundle;
#line 328 "../src/ListStatusesPage.vala"
		main_widget_switch_page (_tmp4_, (gint) PAGE_LISTS, _tmp5_);
#line 322 "../src/ListStatusesPage.vala"
		_g_object_unref0 (bundle);
#line 2104 "ListStatusesPage.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		MainWindow* _tmp7_;
#line 322 "../src/ListStatusesPage.vala"
		e = _inner_error0_;
#line 322 "../src/ListStatusesPage.vala"
		_inner_error0_ = NULL;
#line 330 "../src/ListStatusesPage.vala"
		_tmp6_ = e;
#line 330 "../src/ListStatusesPage.vala"
		_tmp7_ = self->priv->main_window;
#line 330 "../src/ListStatusesPage.vala"
		utils_show_error_dialog (_tmp6_, (GtkWindow*) _tmp7_, NULL, 0);
#line 322 "../src/ListStatusesPage.vala"
		_g_error_free0 (e);
#line 2124 "ListStatusesPage.c"
	}
	__finally0:
#line 322 "../src/ListStatusesPage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 322 "../src/ListStatusesPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 322 "../src/ListStatusesPage.vala"
		g_clear_error (&_inner_error0_);
#line 322 "../src/ListStatusesPage.vala"
		return;
#line 2135 "ListStatusesPage.c"
	}
}

static void
___lambda106__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 321 "../src/ListStatusesPage.vala"
	__lambda106_ ((ListStatusesPage*) self, source_object, res);
#line 321 "../src/ListStatusesPage.vala"
	g_object_unref (self);
#line 2148 "ListStatusesPage.c"
}

static void
list_statuses_page_delete_confirmation_item_clicked_cb (ListStatusesPage* self)
{
	Account* _tmp0_;
#line 320 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/ListStatusesPage.vala"
	_tmp0_ = self->account;
#line 321 "../src/ListStatusesPage.vala"
	list_utils_delete_list (_tmp0_, self->priv->list_id, ___lambda106__gasync_ready_callback, g_object_ref (self));
#line 2161 "ListStatusesPage.c"
}

static void
_list_statuses_page_delete_confirmation_item_clicked_cb_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                                gpointer self)
{
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_delete_confirmation_item_clicked_cb ((ListStatusesPage*) self);
#line 2170 "ListStatusesPage.c"
}

static void
__lambda114_ (ListStatusesPage* self)
{
	GtkButton* _tmp0_;
#line 339 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->refresh_button;
#line 339 "../src/ListStatusesPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 2181 "ListStatusesPage.c"
}

static void
___lambda114__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 338 "../src/ListStatusesPage.vala"
	__lambda114_ ((ListStatusesPage*) self);
#line 338 "../src/ListStatusesPage.vala"
	g_object_unref (self);
#line 2193 "ListStatusesPage.c"
}

static void
list_statuses_page_refresh_button_clicked_cb (ListStatusesPage* self)
{
	GtkButton* _tmp0_;
#line 336 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->refresh_button;
#line 337 "../src/ListStatusesPage.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 338 "../src/ListStatusesPage.vala"
	list_statuses_page_load_newer (self, ___lambda114__gasync_ready_callback, g_object_ref (self));
#line 2208 "ListStatusesPage.c"
}

static void
_list_statuses_page_refresh_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_refresh_button_clicked_cb ((ListStatusesPage*) self);
#line 2217 "ListStatusesPage.c"
}

static void
list_statuses_page_tweet_activated_cb (ListStatusesPage* self,
                                       GtkListBoxRow* row)
{
#line 344 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 344 "../src/ListStatusesPage.vala"
	g_return_if_fail (row != NULL);
#line 345 "../src/ListStatusesPage.vala"
	if (IS_TWEET_LIST_ENTRY (row)) {
#line 2230 "ListStatusesPage.c"
		CbBundle* bundle = NULL;
		CbBundle* _tmp0_;
		CbBundle* _tmp1_;
		CbBundle* _tmp2_;
		CbTweet* _tmp3_;
		MainWindow* _tmp4_;
		MainWidget* _tmp5_;
		CbBundle* _tmp6_;
#line 346 "../src/ListStatusesPage.vala"
		_tmp0_ = cb_bundle_new ();
#line 346 "../src/ListStatusesPage.vala"
		bundle = _tmp0_;
#line 347 "../src/ListStatusesPage.vala"
		_tmp1_ = bundle;
#line 347 "../src/ListStatusesPage.vala"
		cb_bundle_put_int (_tmp1_, TWEET_INFO_PAGE_KEY_MODE, TWEET_INFO_PAGE_BY_INSTANCE);
#line 348 "../src/ListStatusesPage.vala"
		_tmp2_ = bundle;
#line 348 "../src/ListStatusesPage.vala"
		_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (row, TYPE_TWEET_LIST_ENTRY, TweetListEntry)->tweet;
#line 348 "../src/ListStatusesPage.vala"
		cb_bundle_put_object (_tmp2_, TWEET_INFO_PAGE_KEY_TWEET, (GObject*) _tmp3_);
#line 349 "../src/ListStatusesPage.vala"
		_tmp4_ = self->priv->main_window;
#line 349 "../src/ListStatusesPage.vala"
		_tmp5_ = _tmp4_->main_widget;
#line 349 "../src/ListStatusesPage.vala"
		_tmp6_ = bundle;
#line 349 "../src/ListStatusesPage.vala"
		main_widget_switch_page (_tmp5_, (gint) PAGE_TWEET_INFO, _tmp6_);
#line 345 "../src/ListStatusesPage.vala"
		_g_object_unref0 (bundle);
#line 2263 "ListStatusesPage.c"
	} else {
#line 351 "../src/ListStatusesPage.vala"
		g_warning ("ListStatusesPage.vala:351: row is of unknown type");
#line 2267 "ListStatusesPage.c"
	}
}

static void
_list_statuses_page_tweet_activated_cb_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                   GtkListBoxRow* row,
                                                                   gpointer self)
{
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_tweet_activated_cb ((ListStatusesPage*) self, row);
#line 2278 "ListStatusesPage.c"
}

static void
list_statuses_page_load_newer_data_free (gpointer _data)
{
	ListStatusesPageLoadNewerData* _data_;
	_data_ = _data;
#line 19 "../src/ListStatusesPage.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/ListStatusesPage.vala"
	g_slice_free (ListStatusesPageLoadNewerData, _data_);
#line 2290 "ListStatusesPage.c"
}

static void
list_statuses_page_load_newer (ListStatusesPage* self,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ListStatusesPageLoadNewerData* _data_;
	ListStatusesPage* _tmp0_;
#line 19 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/ListStatusesPage.vala"
	_data_ = g_slice_new0 (ListStatusesPageLoadNewerData);
#line 19 "../src/ListStatusesPage.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/ListStatusesPage.vala"
	g_task_set_task_data (_data_->_async_result, _data_, list_statuses_page_load_newer_data_free);
#line 19 "../src/ListStatusesPage.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/ListStatusesPage.vala"
	_data_->self = _tmp0_;
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_load_newer_co (_data_);
#line 2314 "ListStatusesPage.c"
}

static void
list_statuses_page_load_newer_finish (ListStatusesPage* self,
                                      GAsyncResult* _res_)
{
	ListStatusesPageLoadNewerData* _data_;
#line 19 "../src/ListStatusesPage.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2324 "ListStatusesPage.c"
}

static void
list_statuses_page_load_newer_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	ListStatusesPageLoadNewerData* _data_;
#line 372 "../src/ListStatusesPage.vala"
	_data_ = _user_data_;
#line 372 "../src/ListStatusesPage.vala"
	_data_->_source_object_ = source_object;
#line 372 "../src/ListStatusesPage.vala"
	_data_->_res_ = _res_;
#line 372 "../src/ListStatusesPage.vala"
	list_statuses_page_load_newer_co (_data_);
#line 2341 "ListStatusesPage.c"
}

static gboolean
list_statuses_page_load_newer_co (ListStatusesPageLoadNewerData* _data_)
{
#line 354 "../src/ListStatusesPage.vala"
	switch (_data_->_state_) {
#line 354 "../src/ListStatusesPage.vala"
		case 0:
#line 2351 "ListStatusesPage.c"
		goto _state_0;
#line 354 "../src/ListStatusesPage.vala"
		case 1:
#line 2355 "ListStatusesPage.c"
		goto _state_1;
		default:
#line 354 "../src/ListStatusesPage.vala"
		g_assert_not_reached ();
#line 2360 "ListStatusesPage.c"
	}
	_state_0:
#line 355 "../src/ListStatusesPage.vala"
	_data_->_tmp0_ = _data_->self->account;
#line 355 "../src/ListStatusesPage.vala"
	_data_->_tmp1_ = _data_->_tmp0_->proxy;
#line 355 "../src/ListStatusesPage.vala"
	_data_->_tmp2_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp1_);
#line 355 "../src/ListStatusesPage.vala"
	_data_->call = _data_->_tmp2_;
#line 356 "../src/ListStatusesPage.vala"
	_data_->_tmp3_ = _data_->call;
#line 356 "../src/ListStatusesPage.vala"
	rest_proxy_call_set_function (_data_->_tmp3_, "1.1/lists/statuses.json");
#line 357 "../src/ListStatusesPage.vala"
	_data_->_tmp4_ = _data_->call;
#line 357 "../src/ListStatusesPage.vala"
	rest_proxy_call_set_method (_data_->_tmp4_, "GET");
#line 358 "../src/ListStatusesPage.vala"
	_data_->_tmp5_ = _data_->call;
#line 358 "../src/ListStatusesPage.vala"
	_data_->_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->self->priv->list_id);
#line 358 "../src/ListStatusesPage.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 358 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp5_, "list_id", _data_->_tmp7_);
#line 358 "../src/ListStatusesPage.vala"
	_g_free0 (_data_->_tmp7_);
#line 359 "../src/ListStatusesPage.vala"
	_data_->_tmp8_ = _data_->call;
#line 359 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp8_, "count", "30");
#line 360 "../src/ListStatusesPage.vala"
	_data_->_tmp9_ = _data_->call;
#line 360 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp9_, "tweet_mode", "extended");
#line 361 "../src/ListStatusesPage.vala"
	_data_->_tmp10_ = _data_->call;
#line 361 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp10_, "include_ext_alt_text", "true");
#line 362 "../src/ListStatusesPage.vala"
	_data_->_tmp11_ = _data_->self->priv->tweet_list;
#line 362 "../src/ListStatusesPage.vala"
	_data_->_tmp12_ = _data_->_tmp11_->model;
#line 362 "../src/ListStatusesPage.vala"
	_data_->since_id = _data_->_tmp12_->max_id;
#line 363 "../src/ListStatusesPage.vala"
	if (_data_->since_id < ((gint64) 0)) {
#line 364 "../src/ListStatusesPage.vala"
		_data_->since_id = (gint64) 1;
#line 2411 "ListStatusesPage.c"
	}
#line 366 "../src/ListStatusesPage.vala"
	_data_->_tmp13_ = _data_->call;
#line 366 "../src/ListStatusesPage.vala"
	_data_->_tmp14_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->since_id);
#line 366 "../src/ListStatusesPage.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 366 "../src/ListStatusesPage.vala"
	rest_proxy_call_add_param (_data_->_tmp13_, "since_id", _data_->_tmp15_);
#line 366 "../src/ListStatusesPage.vala"
	_g_free0 (_data_->_tmp15_);
#line 367 "../src/ListStatusesPage.vala"
	_data_->_tmp16_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->since_id);
#line 367 "../src/ListStatusesPage.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 367 "../src/ListStatusesPage.vala"
	_data_->_tmp18_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->self->priv->list_id);
#line 367 "../src/ListStatusesPage.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 367 "../src/ListStatusesPage.vala"
	g_debug ("ListStatusesPage.vala:367: Getting statuses since %s for list_id %s", _data_->_tmp17_, _data_->_tmp19_);
#line 367 "../src/ListStatusesPage.vala"
	_g_free0 (_data_->_tmp19_);
#line 367 "../src/ListStatusesPage.vala"
	_g_free0 (_data_->_tmp17_);
#line 370 "../src/ListStatusesPage.vala"
	_data_->root = NULL;
#line 2439 "ListStatusesPage.c"
	{
#line 372 "../src/ListStatusesPage.vala"
		_data_->_tmp21_ = _data_->call;
#line 372 "../src/ListStatusesPage.vala"
		_data_->_state_ = 1;
#line 372 "../src/ListStatusesPage.vala"
		cb_utils_load_threaded_async (_data_->_tmp21_, NULL, list_statuses_page_load_newer_ready, _data_);
#line 372 "../src/ListStatusesPage.vala"
		return FALSE;
#line 2449 "ListStatusesPage.c"
		_state_1:
#line 372 "../src/ListStatusesPage.vala"
		_data_->_tmp22_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
#line 372 "../src/ListStatusesPage.vala"
		_data_->_tmp20_ = _data_->_tmp22_;
#line 372 "../src/ListStatusesPage.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2457 "ListStatusesPage.c"
			goto __catch0_g_error;
		}
#line 372 "../src/ListStatusesPage.vala"
		_data_->_tmp23_ = _data_->_tmp20_;
#line 372 "../src/ListStatusesPage.vala"
		_data_->_tmp20_ = NULL;
#line 372 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 372 "../src/ListStatusesPage.vala"
		_data_->root = _data_->_tmp23_;
#line 371 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->_tmp20_);
#line 2470 "ListStatusesPage.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 371 "../src/ListStatusesPage.vala"
		_data_->e = _data_->_inner_error0_;
#line 371 "../src/ListStatusesPage.vala"
		_data_->_inner_error0_ = NULL;
#line 374 "../src/ListStatusesPage.vala"
		_data_->_tmp24_ = _data_->e;
#line 374 "../src/ListStatusesPage.vala"
		_data_->_tmp25_ = _data_->_tmp24_->message;
#line 374 "../src/ListStatusesPage.vala"
		g_warning ("ListStatusesPage.vala:374: %s", _data_->_tmp25_);
#line 375 "../src/ListStatusesPage.vala"
		_g_error_free0 (_data_->e);
#line 375 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 375 "../src/ListStatusesPage.vala"
		_g_object_unref0 (_data_->call);
#line 375 "../src/ListStatusesPage.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 375 "../src/ListStatusesPage.vala"
		if (_data_->_state_ != 0) {
#line 375 "../src/ListStatusesPage.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 375 "../src/ListStatusesPage.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2499 "ListStatusesPage.c"
			}
		}
#line 375 "../src/ListStatusesPage.vala"
		g_object_unref (_data_->_async_result);
#line 375 "../src/ListStatusesPage.vala"
		return FALSE;
#line 2506 "ListStatusesPage.c"
	}
	__finally0:
#line 371 "../src/ListStatusesPage.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 371 "../src/ListStatusesPage.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 371 "../src/ListStatusesPage.vala"
		_g_object_unref0 (_data_->call);
#line 371 "../src/ListStatusesPage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 371 "../src/ListStatusesPage.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 371 "../src/ListStatusesPage.vala"
		g_object_unref (_data_->_async_result);
#line 371 "../src/ListStatusesPage.vala"
		return FALSE;
#line 2523 "ListStatusesPage.c"
	}
#line 378 "../src/ListStatusesPage.vala"
	_data_->_tmp26_ = _data_->root;
#line 378 "../src/ListStatusesPage.vala"
	_data_->_tmp27_ = json_node_get_array (_data_->_tmp26_);
#line 378 "../src/ListStatusesPage.vala"
	_data_->_tmp28_ = _json_array_ref0 (_data_->_tmp27_);
#line 378 "../src/ListStatusesPage.vala"
	_data_->root_array = _data_->_tmp28_;
#line 379 "../src/ListStatusesPage.vala"
	_data_->_tmp29_ = _data_->root_array;
#line 379 "../src/ListStatusesPage.vala"
	if (json_array_get_length (_data_->_tmp29_) > ((guint) 0)) {
#line 380 "../src/ListStatusesPage.vala"
		_data_->_tmp30_ = _data_->root_array;
#line 380 "../src/ListStatusesPage.vala"
		_data_->_tmp31_ = _data_->self->priv->tweet_list;
#line 380 "../src/ListStatusesPage.vala"
		_data_->_tmp32_ = _data_->self->account;
#line 380 "../src/ListStatusesPage.vala"
		tweet_utils_work_array (_data_->_tmp30_, _data_->_tmp31_, _data_->_tmp32_);
#line 2545 "ListStatusesPage.c"
	}
#line 354 "../src/ListStatusesPage.vala"
	_json_array_unref0 (_data_->root_array);
#line 354 "../src/ListStatusesPage.vala"
	__vala_JsonNode_free0 (_data_->root);
#line 354 "../src/ListStatusesPage.vala"
	_g_object_unref0 (_data_->call);
#line 354 "../src/ListStatusesPage.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 354 "../src/ListStatusesPage.vala"
	if (_data_->_state_ != 0) {
#line 354 "../src/ListStatusesPage.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 354 "../src/ListStatusesPage.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2561 "ListStatusesPage.c"
		}
	}
#line 354 "../src/ListStatusesPage.vala"
	g_object_unref (_data_->_async_result);
#line 354 "../src/ListStatusesPage.vala"
	return FALSE;
#line 2568 "ListStatusesPage.c"
}

static gboolean
___lambda104_ (ListStatusesPage* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	TweetListBox* _tmp2_;
	CbTweetModel* _tmp3_;
	TweetListBox* _tmp4_;
	CbTweetModel* _tmp5_;
	gboolean result;
#line 392 "../src/ListStatusesPage.vala"
	_tmp0_ = scroll_widget_get_scrolled_up ((ScrollWidget*) self);
#line 392 "../src/ListStatusesPage.vala"
	_tmp1_ = _tmp0_;
#line 392 "../src/ListStatusesPage.vala"
	if (!_tmp1_) {
#line 393 "../src/ListStatusesPage.vala"
		self->priv->tweet_remove_timeout = (guint) 0;
#line 394 "../src/ListStatusesPage.vala"
		result = FALSE;
#line 394 "../src/ListStatusesPage.vala"
		return result;
#line 2593 "ListStatusesPage.c"
	}
#line 397 "../src/ListStatusesPage.vala"
	_tmp2_ = self->priv->tweet_list;
#line 397 "../src/ListStatusesPage.vala"
	_tmp3_ = _tmp2_->model;
#line 397 "../src/ListStatusesPage.vala"
	_tmp4_ = self->priv->tweet_list;
#line 397 "../src/ListStatusesPage.vala"
	_tmp5_ = _tmp4_->model;
#line 397 "../src/ListStatusesPage.vala"
	cb_tweet_model_remove_oldest_n_visible (_tmp3_, g_list_model_get_n_items ((GListModel*) _tmp5_) - DEFAULT_TIMELINE_REST);
#line 398 "../src/ListStatusesPage.vala"
	self->priv->tweet_remove_timeout = (guint) 0;
#line 399 "../src/ListStatusesPage.vala"
	result = G_SOURCE_REMOVE;
#line 399 "../src/ListStatusesPage.vala"
	return result;
#line 2611 "ListStatusesPage.c"
}

static gboolean
____lambda104__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda104_ ((ListStatusesPage*) self);
#line 391 "../src/ListStatusesPage.vala"
	return result;
#line 2621 "ListStatusesPage.c"
}

void
list_statuses_page_handle_scrolled_to_start (ListStatusesPage* self)
{
	TweetListBox* _tmp0_;
	CbTweetModel* _tmp1_;
#line 386 "../src/ListStatusesPage.vala"
	g_return_if_fail (self != NULL);
#line 387 "../src/ListStatusesPage.vala"
	if (self->priv->tweet_remove_timeout != ((guint) 0)) {
#line 388 "../src/ListStatusesPage.vala"
		return;
#line 2635 "ListStatusesPage.c"
	}
#line 390 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->tweet_list;
#line 390 "../src/ListStatusesPage.vala"
	_tmp1_ = _tmp0_->model;
#line 390 "../src/ListStatusesPage.vala"
	if (g_list_model_get_n_items ((GListModel*) _tmp1_) > ((guint) DEFAULT_TIMELINE_REST)) {
#line 391 "../src/ListStatusesPage.vala"
		self->priv->tweet_remove_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ____lambda104__gsource_func, g_object_ref (self), g_object_unref);
#line 2645 "ListStatusesPage.c"
	} else {
#line 401 "../src/ListStatusesPage.vala"
		if (self->priv->tweet_remove_timeout != ((guint) 0)) {
#line 402 "../src/ListStatusesPage.vala"
			g_source_remove (self->priv->tweet_remove_timeout);
#line 403 "../src/ListStatusesPage.vala"
			self->priv->tweet_remove_timeout = (guint) 0;
#line 2653 "ListStatusesPage.c"
		}
	}
}

static gchar*
list_statuses_page_real_get_title (IPage* base)
{
	ListStatusesPage * self;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 407 "../src/ListStatusesPage.vala"
	self = (ListStatusesPage*) base;
#line 408 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->title_label;
#line 408 "../src/ListStatusesPage.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 408 "../src/ListStatusesPage.vala"
	_tmp2_ = _tmp1_;
#line 408 "../src/ListStatusesPage.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 408 "../src/ListStatusesPage.vala"
	result = _tmp3_;
#line 408 "../src/ListStatusesPage.vala"
	return result;
#line 2681 "ListStatusesPage.c"
}

static void
list_statuses_page_real_create_radio_button (IPage* base,
                                             GtkRadioButton* group)
{
	ListStatusesPage * self;
#line 411 "../src/ListStatusesPage.vala"
	self = (ListStatusesPage*) base;
#line 2691 "ListStatusesPage.c"
}

static GtkRadioButton*
list_statuses_page_real_get_radio_button (IPage* base)
{
	ListStatusesPage * self;
	GtkRadioButton* result;
#line 412 "../src/ListStatusesPage.vala"
	self = (ListStatusesPage*) base;
#line 412 "../src/ListStatusesPage.vala"
	result = NULL;
#line 412 "../src/ListStatusesPage.vala"
	return result;
#line 2705 "ListStatusesPage.c"
}

static void
list_statuses_page_real_rerun_filters (IPage* base)
{
	ListStatusesPage * self;
	TweetListBox* _tmp0_;
	Account* _tmp1_;
#line 414 "../src/ListStatusesPage.vala"
	self = (ListStatusesPage*) base;
#line 415 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->tweet_list;
#line 415 "../src/ListStatusesPage.vala"
	_tmp1_ = self->account;
#line 415 "../src/ListStatusesPage.vala"
	tweet_utils_rerun_filters (_tmp0_, _tmp1_);
#line 2722 "ListStatusesPage.c"
}

static gint
list_statuses_page_real_get_id (IPage* base)
{
	gint result;
	ListStatusesPage* self;
#line 31 "../src/ListStatusesPage.vala"
	self = (ListStatusesPage*) base;
#line 31 "../src/ListStatusesPage.vala"
	result = self->priv->_id;
#line 31 "../src/ListStatusesPage.vala"
	return result;
#line 2736 "ListStatusesPage.c"
}

static void
list_statuses_page_real_set_id (IPage* base,
                                gint value)
{
	ListStatusesPage* self;
	gint old_value;
#line 31 "../src/ListStatusesPage.vala"
	self = (ListStatusesPage*) base;
#line 31 "../src/ListStatusesPage.vala"
	old_value = list_statuses_page_real_get_id (base);
#line 31 "../src/ListStatusesPage.vala"
	if (old_value != value) {
#line 31 "../src/ListStatusesPage.vala"
		self->priv->_id = value;
#line 31 "../src/ListStatusesPage.vala"
		g_object_notify_by_pspec ((GObject *) self, list_statuses_page_properties[LIST_STATUSES_PAGE_ID_PROPERTY]);
#line 2755 "ListStatusesPage.c"
	}
}

static void
list_statuses_page_real_set_window (IPage* base,
                                    MainWindow* value)
{
	ListStatusesPage* self;
	TweetListBox* _tmp0_;
	MainWindow* _tmp1_;
#line 34 "../src/ListStatusesPage.vala"
	self = (ListStatusesPage*) base;
#line 35 "../src/ListStatusesPage.vala"
	self->priv->main_window = value;
#line 36 "../src/ListStatusesPage.vala"
	_tmp0_ = self->priv->tweet_list;
#line 36 "../src/ListStatusesPage.vala"
	_tmp1_ = self->priv->main_window;
#line 36 "../src/ListStatusesPage.vala"
	tweet_list_box_set_main_window (_tmp0_, _tmp1_);
#line 34 "../src/ListStatusesPage.vala"
	g_object_notify_by_pspec ((GObject *) self, list_statuses_page_properties[LIST_STATUSES_PAGE_WINDOW_PROPERTY]);
#line 2778 "ListStatusesPage.c"
}

static void
list_statuses_page_class_init (ListStatusesPageClass * klass,
                               gpointer klass_data)
{
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/ListStatusesPage.vala"
	g_type_class_adjust_private_offset (klass, &ListStatusesPage_private_offset);
#line 19 "../src/ListStatusesPage.vala"
	((ListStatusesPageClass *) klass)->stream_message_received = (void (*) (ListStatusesPage*, CbStreamMessageType, JsonNode*)) list_statuses_page_real_stream_message_received;
#line 19 "../src/ListStatusesPage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_list_statuses_page_get_property;
#line 19 "../src/ListStatusesPage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_list_statuses_page_set_property;
#line 19 "../src/ListStatusesPage.vala"
	G_OBJECT_CLASS (klass)->finalize = list_statuses_page_finalize;
#line 19 "../src/ListStatusesPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIST_STATUSES_PAGE_ID_PROPERTY, list_statuses_page_properties[LIST_STATUSES_PAGE_ID_PROPERTY] = g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/ListStatusesPage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIST_STATUSES_PAGE_WINDOW_PROPERTY, list_statuses_page_properties[LIST_STATUSES_PAGE_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/uk/co/ibboard/cawbird/ui/list-statuses-page.ui");
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tweet_list", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, tweet_list));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete_button", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, delete_button));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "edit_button", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, edit_button));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "description_label", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, description_label));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "title_label", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, title_label));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "creator_label", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, creator_label));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "subscribers_label", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, subscribers_label));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "members_label", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, members_label));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "created_at_label", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, created_at_label));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "title_stack", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, title_stack));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "title_entry", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, title_entry));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "description_stack", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, description_stack));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "description_entry", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, description_entry));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete_stack", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, delete_stack));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cancel_button", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, cancel_button));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "edit_stack", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, edit_stack));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "save_button", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, save_button));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "mode_stack", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, mode_stack));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "mode_label", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, mode_label));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "mode_combo_box", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, mode_combo_box));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "refresh_button", FALSE, ListStatusesPage_private_offset + G_STRUCT_OFFSET (ListStatusesPagePrivate, refresh_button));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "edit_button_clicked_cb", G_CALLBACK(_list_statuses_page_edit_button_clicked_cb_gtk_button_clicked));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "cancel_button_clicked_cb", G_CALLBACK(_list_statuses_page_cancel_button_clicked_cb_gtk_button_clicked));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "save_button_clicked_cb", G_CALLBACK(_list_statuses_page_save_button_clicked_cb_gtk_button_clicked));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "delete_confirmation_item_clicked_cb", G_CALLBACK(_list_statuses_page_delete_confirmation_item_clicked_cb_gtk_menu_item_activate));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "refresh_button_clicked_cb", G_CALLBACK(_list_statuses_page_refresh_button_clicked_cb_gtk_button_clicked));
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "tweet_activated_cb", G_CALLBACK(_list_statuses_page_tweet_activated_cb_gtk_list_box_row_activated));
#line 2857 "ListStatusesPage.c"
}

static void
list_statuses_page_cb_message_receiver_interface_init (CbMessageReceiverInterface * iface,
                                                       gpointer iface_data)
{
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_cb_message_receiver_parent_iface = g_type_interface_peek_parent (iface);
#line 19 "../src/ListStatusesPage.vala"
	iface->stream_message_received = (void (*) (CbMessageReceiver*, CbStreamMessageType, JsonNode*)) list_statuses_page_stream_message_received;
#line 2868 "ListStatusesPage.c"
}

static void
list_statuses_page_ipage_interface_init (IPageIface * iface,
                                         gpointer iface_data)
{
#line 19 "../src/ListStatusesPage.vala"
	list_statuses_page_ipage_parent_iface = g_type_interface_peek_parent (iface);
#line 19 "../src/ListStatusesPage.vala"
	iface->on_join = (void (*) (IPage*, gint, CbBundle*)) list_statuses_page_real_on_join;
#line 19 "../src/ListStatusesPage.vala"
	iface->on_leave = (void (*) (IPage*)) list_statuses_page_real_on_leave;
#line 19 "../src/ListStatusesPage.vala"
	iface->get_title = (gchar* (*) (IPage*)) list_statuses_page_real_get_title;
#line 19 "../src/ListStatusesPage.vala"
	iface->create_radio_button = (void (*) (IPage*, GtkRadioButton*)) list_statuses_page_real_create_radio_button;
#line 19 "../src/ListStatusesPage.vala"
	iface->get_radio_button = (GtkRadioButton* (*) (IPage*)) list_statuses_page_real_get_radio_button;
#line 19 "../src/ListStatusesPage.vala"
	iface->rerun_filters = (void (*) (IPage*)) list_statuses_page_real_rerun_filters;
#line 19 "../src/ListStatusesPage.vala"
	iface->get_id = list_statuses_page_real_get_id;
#line 19 "../src/ListStatusesPage.vala"
	iface->set_id = list_statuses_page_real_set_id;
#line 19 "../src/ListStatusesPage.vala"
	iface->set_window = list_statuses_page_real_set_window;
#line 2895 "ListStatusesPage.c"
}

static void
list_statuses_page_instance_init (ListStatusesPage * self,
                                  gpointer klass)
{
#line 19 "../src/ListStatusesPage.vala"
	self->priv = list_statuses_page_get_instance_private (self);
#line 41 "../src/ListStatusesPage.vala"
	self->priv->tweet_remove_timeout = (guint) 0;
#line 84 "../src/ListStatusesPage.vala"
	self->priv->loading = FALSE;
#line 19 "../src/ListStatusesPage.vala"
	g_type_ensure (TYPE_TWEET_LIST_BOX);
#line 19 "../src/ListStatusesPage.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2912 "ListStatusesPage.c"
}

static void
list_statuses_page_finalize (GObject * obj)
{
	ListStatusesPage * self;
#line 19 "../src/ListStatusesPage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIST_STATUSES_PAGE, ListStatusesPage);
#line 19 "../src/ListStatusesPage.vala"
	G_OBJECT_CLASS (list_statuses_page_parent_class)->finalize (obj);
#line 2923 "ListStatusesPage.c"
}

static GType
list_statuses_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ListStatusesPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) list_statuses_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ListStatusesPage), 0, (GInstanceInitFunc) list_statuses_page_instance_init, NULL };
	static const GInterfaceInfo cb_message_receiver_info = { (GInterfaceInitFunc) list_statuses_page_cb_message_receiver_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo ipage_info = { (GInterfaceInitFunc) list_statuses_page_ipage_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType list_statuses_page_type_id;
	list_statuses_page_type_id = g_type_register_static (TYPE_SCROLL_WIDGET, "ListStatusesPage", &g_define_type_info, 0);
	g_type_add_interface_static (list_statuses_page_type_id, CB_TYPE_MESSAGE_RECEIVER, &cb_message_receiver_info);
	g_type_add_interface_static (list_statuses_page_type_id, TYPE_IPAGE, &ipage_info);
	ListStatusesPage_private_offset = g_type_add_instance_private (list_statuses_page_type_id, sizeof (ListStatusesPagePrivate));
	return list_statuses_page_type_id;
}

GType
list_statuses_page_get_type (void)
{
	static volatile gsize list_statuses_page_type_id__once = 0;
	if (g_once_init_enter (&list_statuses_page_type_id__once)) {
		GType list_statuses_page_type_id;
		list_statuses_page_type_id = list_statuses_page_get_type_once ();
		g_once_init_leave (&list_statuses_page_type_id__once, list_statuses_page_type_id);
	}
	return list_statuses_page_type_id__once;
}

static void
_vala_list_statuses_page_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	ListStatusesPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LIST_STATUSES_PAGE, ListStatusesPage);
#line 19 "../src/ListStatusesPage.vala"
	switch (property_id) {
#line 19 "../src/ListStatusesPage.vala"
		case LIST_STATUSES_PAGE_ID_PROPERTY:
#line 19 "../src/ListStatusesPage.vala"
		g_value_set_int (value, ipage_get_id ((IPage*) self));
#line 19 "../src/ListStatusesPage.vala"
		break;
#line 2968 "ListStatusesPage.c"
		default:
#line 19 "../src/ListStatusesPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/ListStatusesPage.vala"
		break;
#line 2974 "ListStatusesPage.c"
	}
}

static void
_vala_list_statuses_page_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	ListStatusesPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LIST_STATUSES_PAGE, ListStatusesPage);
#line 19 "../src/ListStatusesPage.vala"
	switch (property_id) {
#line 19 "../src/ListStatusesPage.vala"
		case LIST_STATUSES_PAGE_ID_PROPERTY:
#line 19 "../src/ListStatusesPage.vala"
		ipage_set_id ((IPage*) self, g_value_get_int (value));
#line 19 "../src/ListStatusesPage.vala"
		break;
#line 19 "../src/ListStatusesPage.vala"
		case LIST_STATUSES_PAGE_WINDOW_PROPERTY:
#line 19 "../src/ListStatusesPage.vala"
		ipage_set_window ((IPage*) self, g_value_get_object (value));
#line 19 "../src/ListStatusesPage.vala"
		break;
#line 3000 "ListStatusesPage.c"
		default:
#line 19 "../src/ListStatusesPage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/ListStatusesPage.vala"
		break;
#line 3006 "ListStatusesPage.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

