/* ResizableImage.c generated by valac 0.56.3, the Vala compiler
 * generated from ResizableImage.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2020 IBBoard
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <cairo-gobject.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include "cawbird.h"

#define RESIZABLE_IMAGE_MIN_HEIGHT 120
#define RESIZABLE_IMAGE_MIN_WIDTH 120

#define TYPE_RESIZABLE_IMAGE (resizable_image_get_type ())
#define RESIZABLE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RESIZABLE_IMAGE, ResizableImage))
#define RESIZABLE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RESIZABLE_IMAGE, ResizableImageClass))
#define IS_RESIZABLE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RESIZABLE_IMAGE))
#define IS_RESIZABLE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RESIZABLE_IMAGE))
#define RESIZABLE_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RESIZABLE_IMAGE, ResizableImageClass))

typedef struct _ResizableImage ResizableImage;
typedef struct _ResizableImageClass ResizableImageClass;
typedef struct _ResizableImagePrivate ResizableImagePrivate;
enum  {
	RESIZABLE_IMAGE_0_PROPERTY,
	RESIZABLE_IMAGE_NUM_PROPERTIES
};
static GParamSpec* resizable_image_properties[RESIZABLE_IMAGE_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ResizableImage {
	GtkImage parent_instance;
	ResizableImagePrivate * priv;
	cairo_surface_t* image_surface;
};

struct _ResizableImageClass {
	GtkImageClass parent_class;
};

static gpointer resizable_image_parent_class = NULL;

VALA_EXTERN GType resizable_image_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ResizableImage* resizable_image_new (void);
VALA_EXTERN ResizableImage* resizable_image_construct (GType object_type);
static void resizable_image_get_draw_size (ResizableImage* self,
                                    gint allocated_width,
                                    gint allocated_height,
                                    gint* width,
                                    gint* height,
                                    gdouble* scale);
static gboolean resizable_image_real_draw (GtkWidget* base,
                                    cairo_t* ct);
static GtkSizeRequestMode resizable_image_real_get_request_mode (GtkWidget* base);
static void resizable_image_real_get_preferred_height (GtkWidget* base,
                                                gint* minimum,
                                                gint* natural);
static void resizable_image_real_get_preferred_height_for_width (GtkWidget* base,
                                                          gint width,
                                                          gint* minimum,
                                                          gint* natural);
static void resizable_image_real_get_preferred_width_for_height (GtkWidget* base,
                                                          gint height,
                                                          gint* minimum,
                                                          gint* natural);
static void resizable_image_real_get_preferred_width (GtkWidget* base,
                                               gint* minimum,
                                               gint* natural);
static void resizable_image_finalize (GObject * obj);
static GType resizable_image_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

ResizableImage*
resizable_image_construct (GType object_type)
{
	ResizableImage * self = NULL;
	GtkStyleContext* _tmp0_;
#line 24 "../src/widgets/ResizableImage.vala"
	self = (ResizableImage*) g_object_new (object_type, NULL);
#line 25 "../src/widgets/ResizableImage.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 25 "../src/widgets/ResizableImage.vala"
	gtk_style_context_add_class (_tmp0_, "inline-media");
#line 24 "../src/widgets/ResizableImage.vala"
	return self;
#line 109 "ResizableImage.c"
}

ResizableImage*
resizable_image_new (void)
{
#line 24 "../src/widgets/ResizableImage.vala"
	return resizable_image_construct (TYPE_RESIZABLE_IMAGE);
#line 117 "ResizableImage.c"
}

static void
resizable_image_get_draw_size (ResizableImage* self,
                               gint allocated_width,
                               gint allocated_height,
                               gint* width,
                               gint* height,
                               gdouble* scale)
{
	gint _vala_width = 0;
	gint _vala_height = 0;
	gdouble _vala_scale = 0.0;
	cairo_surface_t* _tmp0_;
#line 28 "../src/widgets/ResizableImage.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/widgets/ResizableImage.vala"
	_tmp0_ = self->image_surface;
#line 30 "../src/widgets/ResizableImage.vala"
	if (_tmp0_ != NULL) {
#line 138 "ResizableImage.c"
		gdouble w = 0.0;
		cairo_surface_t* _tmp1_;
		gdouble h = 0.0;
		cairo_surface_t* _tmp2_;
#line 31 "../src/widgets/ResizableImage.vala"
		_tmp1_ = self->image_surface;
#line 31 "../src/widgets/ResizableImage.vala"
		w = cairo_image_surface_get_width (_tmp1_) * 1.0;
#line 32 "../src/widgets/ResizableImage.vala"
		_tmp2_ = self->image_surface;
#line 32 "../src/widgets/ResizableImage.vala"
		h = cairo_image_surface_get_height (_tmp2_) * 1.0;
#line 33 "../src/widgets/ResizableImage.vala"
		_vala_scale = MIN (1.0, MIN (allocated_width / w, allocated_height / h));
#line 34 "../src/widgets/ResizableImage.vala"
		_vala_width = (gint) floor (w * _vala_scale);
#line 35 "../src/widgets/ResizableImage.vala"
		_vala_height = (gint) floor (h * _vala_scale);
#line 157 "ResizableImage.c"
	} else {
#line 38 "../src/widgets/ResizableImage.vala"
		_vala_width = RESIZABLE_IMAGE_MIN_WIDTH;
#line 39 "../src/widgets/ResizableImage.vala"
		_vala_height = RESIZABLE_IMAGE_MIN_HEIGHT;
#line 40 "../src/widgets/ResizableImage.vala"
		_vala_scale = (gdouble) 1;
#line 165 "ResizableImage.c"
	}
#line 28 "../src/widgets/ResizableImage.vala"
	if (width) {
#line 28 "../src/widgets/ResizableImage.vala"
		*width = _vala_width;
#line 171 "ResizableImage.c"
	}
#line 28 "../src/widgets/ResizableImage.vala"
	if (height) {
#line 28 "../src/widgets/ResizableImage.vala"
		*height = _vala_height;
#line 177 "ResizableImage.c"
	}
#line 28 "../src/widgets/ResizableImage.vala"
	if (scale) {
#line 28 "../src/widgets/ResizableImage.vala"
		*scale = _vala_scale;
#line 183 "ResizableImage.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "../src/widgets/ResizableImage.vala"
	return self ? g_object_ref (self) : NULL;
#line 192 "ResizableImage.c"
}

static gboolean
resizable_image_real_draw (GtkWidget* base,
                           cairo_t* ct)
{
	ResizableImage * self;
	cairo_surface_t* _tmp0_;
	gboolean result;
#line 44 "../src/widgets/ResizableImage.vala"
	self = (ResizableImage*) base;
#line 44 "../src/widgets/ResizableImage.vala"
	g_return_val_if_fail (ct != NULL, FALSE);
#line 45 "../src/widgets/ResizableImage.vala"
	_tmp0_ = self->image_surface;
#line 45 "../src/widgets/ResizableImage.vala"
	if (_tmp0_ != NULL) {
#line 210 "ResizableImage.c"
		gint widget_width = 0;
		gint widget_height = 0;
		gint draw_width = 0;
		gint draw_height = 0;
		gdouble scale = 0.0;
		gint _tmp1_ = 0;
		gint _tmp2_ = 0;
		gdouble _tmp3_ = 0.0;
		gdouble draw_x = 0.0;
		gdouble draw_y = 0.0;
		cairo_surface_t* _tmp4_;
		GtkStyleContext* sc = NULL;
		GtkStyleContext* _tmp5_;
		GtkStyleContext* _tmp6_;
		GtkStyleContext* _tmp7_;
		GtkStyleContext* _tmp8_;
#line 46 "../src/widgets/ResizableImage.vala"
		widget_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 47 "../src/widgets/ResizableImage.vala"
		widget_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 51 "../src/widgets/ResizableImage.vala"
		resizable_image_get_draw_size (self, widget_width, widget_height, &_tmp1_, &_tmp2_, &_tmp3_);
#line 51 "../src/widgets/ResizableImage.vala"
		draw_width = _tmp1_;
#line 51 "../src/widgets/ResizableImage.vala"
		draw_height = _tmp2_;
#line 51 "../src/widgets/ResizableImage.vala"
		scale = _tmp3_;
#line 53 "../src/widgets/ResizableImage.vala"
		draw_x = (gdouble) ((widget_width - draw_width) / 2);
#line 55 "../src/widgets/ResizableImage.vala"
		cairo_save (ct);
#line 56 "../src/widgets/ResizableImage.vala"
		cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) widget_width, (gdouble) widget_height);
#line 57 "../src/widgets/ResizableImage.vala"
		cairo_scale (ct, scale, scale);
#line 58 "../src/widgets/ResizableImage.vala"
		draw_y = (gdouble) ((widget_height - draw_height) / 2);
#line 59 "../src/widgets/ResizableImage.vala"
		_tmp4_ = self->image_surface;
#line 59 "../src/widgets/ResizableImage.vala"
		cairo_set_source_surface (ct, _tmp4_, draw_x / scale, draw_y / scale);
#line 60 "../src/widgets/ResizableImage.vala"
		cairo_paint (ct);
#line 61 "../src/widgets/ResizableImage.vala"
		cairo_restore (ct);
#line 63 "../src/widgets/ResizableImage.vala"
		_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 63 "../src/widgets/ResizableImage.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 63 "../src/widgets/ResizableImage.vala"
		sc = _tmp6_;
#line 64 "../src/widgets/ResizableImage.vala"
		_tmp7_ = sc;
#line 64 "../src/widgets/ResizableImage.vala"
		gtk_render_background (_tmp7_, ct, draw_x, (gdouble) 0, (gdouble) draw_width, (gdouble) draw_height);
#line 65 "../src/widgets/ResizableImage.vala"
		_tmp8_ = sc;
#line 65 "../src/widgets/ResizableImage.vala"
		gtk_render_frame (_tmp8_, ct, draw_x, (gdouble) 0, (gdouble) draw_width, (gdouble) draw_height);
#line 67 "../src/widgets/ResizableImage.vala"
		if (gtk_widget_has_visible_focus ((GtkWidget*) self)) {
#line 273 "ResizableImage.c"
			GtkStyleContext* _tmp9_;
#line 68 "../src/widgets/ResizableImage.vala"
			_tmp9_ = sc;
#line 68 "../src/widgets/ResizableImage.vala"
			gtk_render_focus (_tmp9_, ct, draw_x + 2, (gdouble) 2, (gdouble) (draw_width - 4), (gdouble) (draw_height - 4));
#line 279 "ResizableImage.c"
		}
#line 45 "../src/widgets/ResizableImage.vala"
		_g_object_unref0 (sc);
#line 283 "ResizableImage.c"
	}
#line 72 "../src/widgets/ResizableImage.vala"
	result = GDK_EVENT_PROPAGATE;
#line 72 "../src/widgets/ResizableImage.vala"
	return result;
#line 289 "ResizableImage.c"
}

static GtkSizeRequestMode
resizable_image_real_get_request_mode (GtkWidget* base)
{
	ResizableImage * self;
	GtkSizeRequestMode result;
#line 75 "../src/widgets/ResizableImage.vala"
	self = (ResizableImage*) base;
#line 76 "../src/widgets/ResizableImage.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 76 "../src/widgets/ResizableImage.vala"
	return result;
#line 303 "ResizableImage.c"
}

static void
resizable_image_real_get_preferred_height (GtkWidget* base,
                                           gint* minimum,
                                           gint* natural)
{
	ResizableImage * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _tmp0_ = 0;
	cairo_surface_t* _tmp1_;
	gint media_height = 0;
#line 79 "../src/widgets/ResizableImage.vala"
	self = (ResizableImage*) base;
#line 81 "../src/widgets/ResizableImage.vala"
	_tmp1_ = self->image_surface;
#line 81 "../src/widgets/ResizableImage.vala"
	if (_tmp1_ != NULL) {
#line 323 "ResizableImage.c"
		cairo_surface_t* _tmp2_;
#line 81 "../src/widgets/ResizableImage.vala"
		_tmp2_ = self->image_surface;
#line 81 "../src/widgets/ResizableImage.vala"
		_tmp0_ = cairo_image_surface_get_height (_tmp2_);
#line 329 "ResizableImage.c"
	} else {
#line 81 "../src/widgets/ResizableImage.vala"
		_tmp0_ = RESIZABLE_IMAGE_MIN_HEIGHT;
#line 333 "ResizableImage.c"
	}
#line 81 "../src/widgets/ResizableImage.vala"
	media_height = _tmp0_;
#line 82 "../src/widgets/ResizableImage.vala"
	_vala_minimum = MIN (media_height, RESIZABLE_IMAGE_MIN_HEIGHT);
#line 83 "../src/widgets/ResizableImage.vala"
	_vala_natural = media_height;
#line 79 "../src/widgets/ResizableImage.vala"
	if (minimum) {
#line 79 "../src/widgets/ResizableImage.vala"
		*minimum = _vala_minimum;
#line 345 "ResizableImage.c"
	}
#line 79 "../src/widgets/ResizableImage.vala"
	if (natural) {
#line 79 "../src/widgets/ResizableImage.vala"
		*natural = _vala_natural;
#line 351 "ResizableImage.c"
	}
}

static void
resizable_image_real_get_preferred_height_for_width (GtkWidget* base,
                                                     gint width,
                                                     gint* minimum,
                                                     gint* natural)
{
	ResizableImage * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _tmp0_ = 0;
	cairo_surface_t* _tmp1_;
	gint media_width = 0;
	gint _tmp3_ = 0;
	cairo_surface_t* _tmp4_;
	gint media_height = 0;
	gdouble scale = 0.0;
#line 86 "../src/widgets/ResizableImage.vala"
	self = (ResizableImage*) base;
#line 89 "../src/widgets/ResizableImage.vala"
	_tmp1_ = self->image_surface;
#line 89 "../src/widgets/ResizableImage.vala"
	if (_tmp1_ != NULL) {
#line 377 "ResizableImage.c"
		cairo_surface_t* _tmp2_;
#line 89 "../src/widgets/ResizableImage.vala"
		_tmp2_ = self->image_surface;
#line 89 "../src/widgets/ResizableImage.vala"
		_tmp0_ = cairo_image_surface_get_width (_tmp2_);
#line 383 "ResizableImage.c"
	} else {
#line 89 "../src/widgets/ResizableImage.vala"
		_tmp0_ = RESIZABLE_IMAGE_MIN_WIDTH;
#line 387 "ResizableImage.c"
	}
#line 89 "../src/widgets/ResizableImage.vala"
	media_width = _tmp0_;
#line 90 "../src/widgets/ResizableImage.vala"
	_tmp4_ = self->image_surface;
#line 90 "../src/widgets/ResizableImage.vala"
	if (_tmp4_ != NULL) {
#line 395 "ResizableImage.c"
		cairo_surface_t* _tmp5_;
#line 90 "../src/widgets/ResizableImage.vala"
		_tmp5_ = self->image_surface;
#line 90 "../src/widgets/ResizableImage.vala"
		_tmp3_ = cairo_image_surface_get_height (_tmp5_);
#line 401 "ResizableImage.c"
	} else {
#line 90 "../src/widgets/ResizableImage.vala"
		_tmp3_ = RESIZABLE_IMAGE_MIN_HEIGHT;
#line 405 "ResizableImage.c"
	}
#line 90 "../src/widgets/ResizableImage.vala"
	media_height = _tmp3_;
#line 92 "../src/widgets/ResizableImage.vala"
	scale = width / ((gdouble) media_width);
#line 94 "../src/widgets/ResizableImage.vala"
	if (scale >= ((gdouble) 1)) {
#line 95 "../src/widgets/ResizableImage.vala"
		_vala_natural = media_height;
#line 415 "ResizableImage.c"
	} else {
#line 97 "../src/widgets/ResizableImage.vala"
		_vala_natural = (gint) floor (media_height * scale);
#line 419 "ResizableImage.c"
	}
#line 100 "../src/widgets/ResizableImage.vala"
	_vala_minimum = MIN (media_height, RESIZABLE_IMAGE_MIN_HEIGHT);
#line 86 "../src/widgets/ResizableImage.vala"
	if (minimum) {
#line 86 "../src/widgets/ResizableImage.vala"
		*minimum = _vala_minimum;
#line 427 "ResizableImage.c"
	}
#line 86 "../src/widgets/ResizableImage.vala"
	if (natural) {
#line 86 "../src/widgets/ResizableImage.vala"
		*natural = _vala_natural;
#line 433 "ResizableImage.c"
	}
}

static void
resizable_image_real_get_preferred_width_for_height (GtkWidget* base,
                                                     gint height,
                                                     gint* minimum,
                                                     gint* natural)
{
	ResizableImage * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _tmp0_ = 0;
	cairo_surface_t* _tmp1_;
	gint media_width = 0;
	gint _tmp3_ = 0;
	cairo_surface_t* _tmp4_;
	gint media_height = 0;
	gdouble scale = 0.0;
#line 103 "../src/widgets/ResizableImage.vala"
	self = (ResizableImage*) base;
#line 107 "../src/widgets/ResizableImage.vala"
	_tmp1_ = self->image_surface;
#line 107 "../src/widgets/ResizableImage.vala"
	if (_tmp1_ != NULL) {
#line 459 "ResizableImage.c"
		cairo_surface_t* _tmp2_;
#line 107 "../src/widgets/ResizableImage.vala"
		_tmp2_ = self->image_surface;
#line 107 "../src/widgets/ResizableImage.vala"
		_tmp0_ = cairo_image_surface_get_width (_tmp2_);
#line 465 "ResizableImage.c"
	} else {
#line 107 "../src/widgets/ResizableImage.vala"
		_tmp0_ = RESIZABLE_IMAGE_MIN_WIDTH;
#line 469 "ResizableImage.c"
	}
#line 107 "../src/widgets/ResizableImage.vala"
	media_width = _tmp0_;
#line 108 "../src/widgets/ResizableImage.vala"
	_tmp4_ = self->image_surface;
#line 108 "../src/widgets/ResizableImage.vala"
	if (_tmp4_ != NULL) {
#line 477 "ResizableImage.c"
		cairo_surface_t* _tmp5_;
#line 108 "../src/widgets/ResizableImage.vala"
		_tmp5_ = self->image_surface;
#line 108 "../src/widgets/ResizableImage.vala"
		_tmp3_ = cairo_image_surface_get_height (_tmp5_);
#line 483 "ResizableImage.c"
	} else {
#line 108 "../src/widgets/ResizableImage.vala"
		_tmp3_ = RESIZABLE_IMAGE_MIN_HEIGHT;
#line 487 "ResizableImage.c"
	}
#line 108 "../src/widgets/ResizableImage.vala"
	media_height = _tmp3_;
#line 110 "../src/widgets/ResizableImage.vala"
	scale = height / ((gdouble) media_height);
#line 112 "../src/widgets/ResizableImage.vala"
	if (scale >= ((gdouble) 1)) {
#line 113 "../src/widgets/ResizableImage.vala"
		_vala_natural = media_width;
#line 497 "ResizableImage.c"
	} else {
#line 115 "../src/widgets/ResizableImage.vala"
		_vala_natural = (gint) floor (media_width * scale);
#line 501 "ResizableImage.c"
	}
#line 118 "../src/widgets/ResizableImage.vala"
	_vala_minimum = MIN (media_width, RESIZABLE_IMAGE_MIN_WIDTH);
#line 103 "../src/widgets/ResizableImage.vala"
	if (minimum) {
#line 103 "../src/widgets/ResizableImage.vala"
		*minimum = _vala_minimum;
#line 509 "ResizableImage.c"
	}
#line 103 "../src/widgets/ResizableImage.vala"
	if (natural) {
#line 103 "../src/widgets/ResizableImage.vala"
		*natural = _vala_natural;
#line 515 "ResizableImage.c"
	}
}

static void
resizable_image_real_get_preferred_width (GtkWidget* base,
                                          gint* minimum,
                                          gint* natural)
{
	ResizableImage * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _tmp0_ = 0;
	cairo_surface_t* _tmp1_;
	gint media_width = 0;
#line 121 "../src/widgets/ResizableImage.vala"
	self = (ResizableImage*) base;
#line 123 "../src/widgets/ResizableImage.vala"
	_tmp1_ = self->image_surface;
#line 123 "../src/widgets/ResizableImage.vala"
	if (_tmp1_ != NULL) {
#line 536 "ResizableImage.c"
		cairo_surface_t* _tmp2_;
#line 123 "../src/widgets/ResizableImage.vala"
		_tmp2_ = self->image_surface;
#line 123 "../src/widgets/ResizableImage.vala"
		_tmp0_ = cairo_image_surface_get_width (_tmp2_);
#line 542 "ResizableImage.c"
	} else {
#line 123 "../src/widgets/ResizableImage.vala"
		_tmp0_ = RESIZABLE_IMAGE_MIN_WIDTH;
#line 546 "ResizableImage.c"
	}
#line 123 "../src/widgets/ResizableImage.vala"
	media_width = _tmp0_;
#line 125 "../src/widgets/ResizableImage.vala"
	_vala_minimum = MIN (media_width, RESIZABLE_IMAGE_MIN_WIDTH);
#line 126 "../src/widgets/ResizableImage.vala"
	_vala_natural = media_width;
#line 121 "../src/widgets/ResizableImage.vala"
	if (minimum) {
#line 121 "../src/widgets/ResizableImage.vala"
		*minimum = _vala_minimum;
#line 558 "ResizableImage.c"
	}
#line 121 "../src/widgets/ResizableImage.vala"
	if (natural) {
#line 121 "../src/widgets/ResizableImage.vala"
		*natural = _vala_natural;
#line 564 "ResizableImage.c"
	}
}

static void
resizable_image_class_init (ResizableImageClass * klass,
                            gpointer klass_data)
{
#line 18 "../src/widgets/ResizableImage.vala"
	resizable_image_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/ResizableImage.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) resizable_image_real_draw;
#line 18 "../src/widgets/ResizableImage.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) resizable_image_real_get_request_mode;
#line 18 "../src/widgets/ResizableImage.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) resizable_image_real_get_preferred_height;
#line 18 "../src/widgets/ResizableImage.vala"
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) resizable_image_real_get_preferred_height_for_width;
#line 18 "../src/widgets/ResizableImage.vala"
	((GtkWidgetClass *) klass)->get_preferred_width_for_height = (void (*) (GtkWidget*, gint, gint*, gint*)) resizable_image_real_get_preferred_width_for_height;
#line 18 "../src/widgets/ResizableImage.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) resizable_image_real_get_preferred_width;
#line 18 "../src/widgets/ResizableImage.vala"
	G_OBJECT_CLASS (klass)->finalize = resizable_image_finalize;
#line 588 "ResizableImage.c"
}

static void
resizable_image_instance_init (ResizableImage * self,
                               gpointer klass)
{
#line 22 "../src/widgets/ResizableImage.vala"
	self->image_surface = NULL;
#line 597 "ResizableImage.c"
}

static void
resizable_image_finalize (GObject * obj)
{
	ResizableImage * self;
#line 18 "../src/widgets/ResizableImage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RESIZABLE_IMAGE, ResizableImage);
#line 22 "../src/widgets/ResizableImage.vala"
	_cairo_surface_destroy0 (self->image_surface);
#line 18 "../src/widgets/ResizableImage.vala"
	G_OBJECT_CLASS (resizable_image_parent_class)->finalize (obj);
#line 610 "ResizableImage.c"
}

static GType
resizable_image_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ResizableImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) resizable_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ResizableImage), 0, (GInstanceInitFunc) resizable_image_instance_init, NULL };
	GType resizable_image_type_id;
	resizable_image_type_id = g_type_register_static (gtk_image_get_type (), "ResizableImage", &g_define_type_info, 0);
	return resizable_image_type_id;
}

GType
resizable_image_get_type (void)
{
	static volatile gsize resizable_image_type_id__once = 0;
	if (g_once_init_enter (&resizable_image_type_id__once)) {
		GType resizable_image_type_id;
		resizable_image_type_id = resizable_image_get_type_once ();
		g_once_init_leave (&resizable_image_type_id__once, resizable_image_type_id);
	}
	return resizable_image_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

