/* ScrollWidget.c generated by valac 0.56.3, the Vala compiler
 * generated from ScrollWidget.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include "cawbird.h"
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <string.h>

#define TOP 1
#define BOTTOM 2
#define NONE 0
#define TRANSITION_DURATION (200 * 1000)

enum  {
	SCROLL_WIDGET_0_PROPERTY,
	SCROLL_WIDGET_END_DIFF_PROPERTY,
	SCROLL_WIDGET_SCROLLED_DOWN_PROPERTY,
	SCROLL_WIDGET_SCROLLED_UP_PROPERTY,
	SCROLL_WIDGET_IS_SCROLLABLE_PROPERTY,
	SCROLL_WIDGET_NUM_PROPERTIES
};
static GParamSpec* scroll_widget_properties[SCROLL_WIDGET_NUM_PROPERTIES];
typedef struct _Block85Data Block85Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block86Data Block86Data;
enum  {
	SCROLL_WIDGET_SCROLLED_TO_START_SIGNAL,
	SCROLL_WIDGET_SCROLLED_TO_END_SIGNAL,
	SCROLL_WIDGET_NUM_SIGNALS
};
static guint scroll_widget_signals[SCROLL_WIDGET_NUM_SIGNALS] = {0};

struct _ScrollWidgetPrivate {
	gdouble upper_cache;
	gdouble value_cache;
	gint balance;
	gdouble _end_diff;
	gulong scroll_down_id;
	gulong scroll_up_id;
	gint64 start_time;
	gint64 end_time;
	gdouble transition_diff;
	gdouble transition_start_value;
};

struct _Block85Data {
	int _ref_count_;
	ScrollWidget* self;
	gboolean animate;
};

struct _Block86Data {
	int _ref_count_;
	ScrollWidget* self;
	gboolean animate;
};

static gint ScrollWidget_private_offset;
static gpointer scroll_widget_parent_class = NULL;

static void scroll_widget_keep_upper_func (ScrollWidget* self);
static void scroll_widget_keep_value_func (ScrollWidget* self);
static Block85Data* block85_data_ref (Block85Data* _data85_);
static void block85_data_unref (void * _userdata_);
static gboolean scroll_widget_scroll_up_tick_cb (ScrollWidget* self,
                                          GtkWidget* widget,
                                          GdkFrameClock* frame_clock);
static gboolean _scroll_widget_scroll_up_tick_cb_gtk_tick_callback (GtkWidget* widget,
                                                             GdkFrameClock* frame_clock,
                                                             gpointer self);
static void ___lambda32_ (Block85Data* _data85_);
static void ____lambda32__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static Block86Data* block86_data_ref (Block86Data* _data86_);
static void block86_data_unref (void * _userdata_);
static void __lambda33_ (Block86Data* _data86_);
static void ___lambda33__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
VALA_EXTERN gdouble ease_out_cubic (gdouble t);
static GObject * scroll_widget_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _scroll_widget_keep_upper_func_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _scroll_widget_keep_value_func_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void scroll_widget_finalize (GObject * obj);
static GType scroll_widget_get_type_once (void);
static void _vala_scroll_widget_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_scroll_widget_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
scroll_widget_get_instance_private (ScrollWidget* self)
{
	return G_STRUCT_MEMBER_P (self, ScrollWidget_private_offset);
}

static void
scroll_widget_keep_upper_func (ScrollWidget* self)
{
	gdouble upper = 0.0;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GtkAdjustment* _tmp10_;
	GtkAdjustment* _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	GtkAdjustment* _tmp14_;
	GtkAdjustment* _tmp15_;
	gdouble _tmp16_;
	gdouble _tmp17_;
#line 57 "../src/widgets/ScrollWidget.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 58 "../src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_adjustment_get_upper (_tmp1_);
#line 58 "../src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 58 "../src/widgets/ScrollWidget.vala"
	upper = _tmp3_;
#line 59 "../src/widgets/ScrollWidget.vala"
	if (self->priv->balance == TOP) {
#line 162 "ScrollWidget.c"
		gdouble inc = 0.0;
		GtkAdjustment* _tmp4_;
		GtkAdjustment* _tmp5_;
		GtkAdjustment* _tmp6_;
		GtkAdjustment* _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
#line 60 "../src/widgets/ScrollWidget.vala"
		inc = upper - self->priv->upper_cache;
#line 62 "../src/widgets/ScrollWidget.vala"
		_tmp4_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 62 "../src/widgets/ScrollWidget.vala"
		_tmp5_ = _tmp4_;
#line 62 "../src/widgets/ScrollWidget.vala"
		_tmp6_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 62 "../src/widgets/ScrollWidget.vala"
		_tmp7_ = _tmp6_;
#line 62 "../src/widgets/ScrollWidget.vala"
		_tmp8_ = gtk_adjustment_get_value (_tmp7_);
#line 62 "../src/widgets/ScrollWidget.vala"
		_tmp9_ = _tmp8_;
#line 62 "../src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp7_, _tmp9_ + inc);
#line 63 "../src/widgets/ScrollWidget.vala"
		self->priv->balance = NONE;
#line 188 "ScrollWidget.c"
	}
#line 65 "../src/widgets/ScrollWidget.vala"
	_tmp10_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 65 "../src/widgets/ScrollWidget.vala"
	_tmp11_ = _tmp10_;
#line 65 "../src/widgets/ScrollWidget.vala"
	_tmp12_ = gtk_adjustment_get_upper (_tmp11_);
#line 65 "../src/widgets/ScrollWidget.vala"
	_tmp13_ = _tmp12_;
#line 65 "../src/widgets/ScrollWidget.vala"
	self->priv->upper_cache = _tmp13_;
#line 66 "../src/widgets/ScrollWidget.vala"
	_tmp14_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 66 "../src/widgets/ScrollWidget.vala"
	_tmp15_ = _tmp14_;
#line 66 "../src/widgets/ScrollWidget.vala"
	_tmp16_ = gtk_adjustment_get_value (_tmp15_);
#line 66 "../src/widgets/ScrollWidget.vala"
	_tmp17_ = _tmp16_;
#line 66 "../src/widgets/ScrollWidget.vala"
	self->priv->value_cache = _tmp17_;
#line 210 "ScrollWidget.c"
}

static void
scroll_widget_keep_value_func (ScrollWidget* self)
{
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble max = 0.0;
	GtkAdjustment* _tmp8_;
	GtkAdjustment* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GtkAdjustment* _tmp12_;
	GtkAdjustment* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	GtkAdjustment* _tmp16_;
	GtkAdjustment* _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	gdouble upper = 0.0;
	GtkAdjustment* _tmp21_;
	GtkAdjustment* _tmp22_;
	gdouble _tmp23_;
	gdouble _tmp24_;
	GtkAdjustment* _tmp31_;
	GtkAdjustment* _tmp32_;
	gdouble _tmp33_;
	gdouble _tmp34_;
	GtkAdjustment* _tmp35_;
	GtkAdjustment* _tmp36_;
	gdouble _tmp37_;
	gdouble _tmp38_;
#line 69 "../src/widgets/ScrollWidget.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 71 "../src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 71 "../src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
#line 71 "../src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 71 "../src/widgets/ScrollWidget.vala"
	if (_tmp3_ < 10.0) {
#line 259 "ScrollWidget.c"
		GtkAdjustment* _tmp4_;
		GtkAdjustment* _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
#line 72 "../src/widgets/ScrollWidget.vala"
		_tmp4_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 72 "../src/widgets/ScrollWidget.vala"
		_tmp5_ = _tmp4_;
#line 72 "../src/widgets/ScrollWidget.vala"
		_tmp6_ = gtk_adjustment_get_value (_tmp5_);
#line 72 "../src/widgets/ScrollWidget.vala"
		_tmp7_ = _tmp6_;
#line 72 "../src/widgets/ScrollWidget.vala"
		g_signal_emit (self, scroll_widget_signals[SCROLL_WIDGET_SCROLLED_TO_START_SIGNAL], 0, _tmp7_);
#line 274 "ScrollWidget.c"
	}
#line 75 "../src/widgets/ScrollWidget.vala"
	_tmp8_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 75 "../src/widgets/ScrollWidget.vala"
	_tmp9_ = _tmp8_;
#line 75 "../src/widgets/ScrollWidget.vala"
	_tmp10_ = gtk_adjustment_get_upper (_tmp9_);
#line 75 "../src/widgets/ScrollWidget.vala"
	_tmp11_ = _tmp10_;
#line 75 "../src/widgets/ScrollWidget.vala"
	_tmp12_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 75 "../src/widgets/ScrollWidget.vala"
	_tmp13_ = _tmp12_;
#line 75 "../src/widgets/ScrollWidget.vala"
	_tmp14_ = gtk_adjustment_get_page_size (_tmp13_);
#line 75 "../src/widgets/ScrollWidget.vala"
	_tmp15_ = _tmp14_;
#line 75 "../src/widgets/ScrollWidget.vala"
	max = _tmp11_ - _tmp15_;
#line 76 "../src/widgets/ScrollWidget.vala"
	_tmp16_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 76 "../src/widgets/ScrollWidget.vala"
	_tmp17_ = _tmp16_;
#line 76 "../src/widgets/ScrollWidget.vala"
	_tmp18_ = gtk_adjustment_get_value (_tmp17_);
#line 76 "../src/widgets/ScrollWidget.vala"
	_tmp19_ = _tmp18_;
#line 76 "../src/widgets/ScrollWidget.vala"
	_tmp20_ = self->priv->_end_diff;
#line 76 "../src/widgets/ScrollWidget.vala"
	if (_tmp19_ >= (max - _tmp20_)) {
#line 77 "../src/widgets/ScrollWidget.vala"
		g_signal_emit (self, scroll_widget_signals[SCROLL_WIDGET_SCROLLED_TO_END_SIGNAL], 0);
#line 308 "ScrollWidget.c"
	}
#line 79 "../src/widgets/ScrollWidget.vala"
	_tmp21_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 79 "../src/widgets/ScrollWidget.vala"
	_tmp22_ = _tmp21_;
#line 79 "../src/widgets/ScrollWidget.vala"
	_tmp23_ = gtk_adjustment_get_upper (_tmp22_);
#line 79 "../src/widgets/ScrollWidget.vala"
	_tmp24_ = _tmp23_;
#line 79 "../src/widgets/ScrollWidget.vala"
	upper = _tmp24_;
#line 80 "../src/widgets/ScrollWidget.vala"
	if (self->priv->balance == BOTTOM) {
#line 322 "ScrollWidget.c"
		gdouble inc = 0.0;
		GtkAdjustment* _tmp25_;
		GtkAdjustment* _tmp26_;
		GtkAdjustment* _tmp27_;
		GtkAdjustment* _tmp28_;
		gdouble _tmp29_;
		gdouble _tmp30_;
#line 81 "../src/widgets/ScrollWidget.vala"
		inc = upper - self->priv->upper_cache;
#line 83 "../src/widgets/ScrollWidget.vala"
		_tmp25_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 83 "../src/widgets/ScrollWidget.vala"
		_tmp26_ = _tmp25_;
#line 83 "../src/widgets/ScrollWidget.vala"
		_tmp27_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 83 "../src/widgets/ScrollWidget.vala"
		_tmp28_ = _tmp27_;
#line 83 "../src/widgets/ScrollWidget.vala"
		_tmp29_ = gtk_adjustment_get_value (_tmp28_);
#line 83 "../src/widgets/ScrollWidget.vala"
		_tmp30_ = _tmp29_;
#line 83 "../src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp28_, _tmp30_ - inc);
#line 84 "../src/widgets/ScrollWidget.vala"
		self->priv->balance = NONE;
#line 348 "ScrollWidget.c"
	}
#line 86 "../src/widgets/ScrollWidget.vala"
	_tmp31_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 86 "../src/widgets/ScrollWidget.vala"
	_tmp32_ = _tmp31_;
#line 86 "../src/widgets/ScrollWidget.vala"
	_tmp33_ = gtk_adjustment_get_upper (_tmp32_);
#line 86 "../src/widgets/ScrollWidget.vala"
	_tmp34_ = _tmp33_;
#line 86 "../src/widgets/ScrollWidget.vala"
	self->priv->upper_cache = _tmp34_;
#line 87 "../src/widgets/ScrollWidget.vala"
	_tmp35_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 87 "../src/widgets/ScrollWidget.vala"
	_tmp36_ = _tmp35_;
#line 87 "../src/widgets/ScrollWidget.vala"
	_tmp37_ = gtk_adjustment_get_value (_tmp36_);
#line 87 "../src/widgets/ScrollWidget.vala"
	_tmp38_ = _tmp37_;
#line 87 "../src/widgets/ScrollWidget.vala"
	self->priv->value_cache = _tmp38_;
#line 370 "ScrollWidget.c"
}

void
scroll_widget_balance_next_upper_change (ScrollWidget* self,
                                         gint mode)
{
#line 90 "../src/widgets/ScrollWidget.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/widgets/ScrollWidget.vala"
	self->priv->balance = mode;
#line 381 "ScrollWidget.c"
}

/**
   * TODO: Update scroll_down_next
   * Scroll to the very top of the scrolled window once the next
   * size_allocate occurs.
   * This will use a transition if the correct Gtk+ settings is set
   * to true.
   *
   * @param animate    Whether to animate/transition the change or not (default: true)
   */
static Block85Data*
block85_data_ref (Block85Data* _data85_)
{
#line 104 "../src/widgets/ScrollWidget.vala"
	g_atomic_int_inc (&_data85_->_ref_count_);
#line 104 "../src/widgets/ScrollWidget.vala"
	return _data85_;
#line 400 "ScrollWidget.c"
}

static void
block85_data_unref (void * _userdata_)
{
	Block85Data* _data85_;
	_data85_ = (Block85Data*) _userdata_;
#line 104 "../src/widgets/ScrollWidget.vala"
	if (g_atomic_int_dec_and_test (&_data85_->_ref_count_)) {
#line 410 "ScrollWidget.c"
		ScrollWidget* self;
#line 104 "../src/widgets/ScrollWidget.vala"
		self = _data85_->self;
#line 104 "../src/widgets/ScrollWidget.vala"
		_g_object_unref0 (self);
#line 104 "../src/widgets/ScrollWidget.vala"
		g_slice_free (Block85Data, _data85_);
#line 418 "ScrollWidget.c"
	}
}

static gboolean
_scroll_widget_scroll_up_tick_cb_gtk_tick_callback (GtkWidget* widget,
                                                    GdkFrameClock* frame_clock,
                                                    gpointer self)
{
	gboolean result;
	result = scroll_widget_scroll_up_tick_cb ((ScrollWidget*) self, widget, frame_clock);
#line 118 "../src/widgets/ScrollWidget.vala"
	return result;
#line 431 "ScrollWidget.c"
}

static void
___lambda32_ (Block85Data* _data85_)
{
	ScrollWidget* self;
	gboolean _tmp0_ = FALSE;
	GtkSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkAdjustment* _tmp15_;
	GtkAdjustment* _tmp16_;
#line 128 "../src/widgets/ScrollWidget.vala"
	self = _data85_->self;
#line 129 "../src/widgets/ScrollWidget.vala"
	_tmp1_ = gtk_settings_get_default ();
#line 129 "../src/widgets/ScrollWidget.vala"
	g_object_get (_tmp1_, "gtk-enable-animations", &_tmp2_, NULL);
#line 129 "../src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 129 "../src/widgets/ScrollWidget.vala"
	if (_tmp3_) {
#line 129 "../src/widgets/ScrollWidget.vala"
		_tmp0_ = _data85_->animate;
#line 456 "ScrollWidget.c"
	} else {
#line 129 "../src/widgets/ScrollWidget.vala"
		_tmp0_ = FALSE;
#line 460 "ScrollWidget.c"
	}
#line 129 "../src/widgets/ScrollWidget.vala"
	if (_tmp0_) {
#line 464 "ScrollWidget.c"
		GdkFrameClock* _tmp4_;
		GtkAdjustment* _tmp5_;
		GtkAdjustment* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		GtkAdjustment* _tmp9_;
		GtkAdjustment* _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
#line 130 "../src/widgets/ScrollWidget.vala"
		_tmp4_ = gtk_widget_get_frame_clock ((GtkWidget*) self);
#line 130 "../src/widgets/ScrollWidget.vala"
		self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp4_);
#line 131 "../src/widgets/ScrollWidget.vala"
		self->priv->end_time = self->priv->start_time + TRANSITION_DURATION;
#line 132 "../src/widgets/ScrollWidget.vala"
		_tmp5_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 132 "../src/widgets/ScrollWidget.vala"
		_tmp6_ = _tmp5_;
#line 132 "../src/widgets/ScrollWidget.vala"
		_tmp7_ = gtk_adjustment_get_value (_tmp6_);
#line 132 "../src/widgets/ScrollWidget.vala"
		_tmp8_ = _tmp7_;
#line 132 "../src/widgets/ScrollWidget.vala"
		self->priv->transition_diff = -_tmp8_;
#line 133 "../src/widgets/ScrollWidget.vala"
		_tmp9_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 133 "../src/widgets/ScrollWidget.vala"
		_tmp10_ = _tmp9_;
#line 133 "../src/widgets/ScrollWidget.vala"
		_tmp11_ = gtk_adjustment_get_value (_tmp10_);
#line 133 "../src/widgets/ScrollWidget.vala"
		_tmp12_ = _tmp11_;
#line 133 "../src/widgets/ScrollWidget.vala"
		self->priv->transition_start_value = _tmp12_;
#line 134 "../src/widgets/ScrollWidget.vala"
		gtk_widget_add_tick_callback ((GtkWidget*) self, _scroll_widget_scroll_up_tick_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 502 "ScrollWidget.c"
	} else {
		GtkAdjustment* _tmp13_;
		GtkAdjustment* _tmp14_;
#line 136 "../src/widgets/ScrollWidget.vala"
		_tmp13_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 136 "../src/widgets/ScrollWidget.vala"
		_tmp14_ = _tmp13_;
#line 136 "../src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp14_, (gdouble) 0);
#line 512 "ScrollWidget.c"
	}
#line 138 "../src/widgets/ScrollWidget.vala"
	_tmp15_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 138 "../src/widgets/ScrollWidget.vala"
	_tmp16_ = _tmp15_;
#line 138 "../src/widgets/ScrollWidget.vala"
	g_signal_handler_disconnect ((GObject*) _tmp16_, self->priv->scroll_up_id);
#line 139 "../src/widgets/ScrollWidget.vala"
	self->priv->scroll_up_id = (gulong) 0;
#line 522 "ScrollWidget.c"
}

static void
____lambda32__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 128 "../src/widgets/ScrollWidget.vala"
	___lambda32_ (self);
#line 532 "ScrollWidget.c"
}

void
scroll_widget_scroll_up_next (ScrollWidget* self,
                              gboolean animate,
                              gboolean force_start)
{
	Block85Data* _data85_;
#line 104 "../src/widgets/ScrollWidget.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/widgets/ScrollWidget.vala"
	_data85_ = g_slice_new0 (Block85Data);
#line 104 "../src/widgets/ScrollWidget.vala"
	_data85_->_ref_count_ = 1;
#line 104 "../src/widgets/ScrollWidget.vala"
	_data85_->self = g_object_ref (self);
#line 104 "../src/widgets/ScrollWidget.vala"
	_data85_->animate = animate;
#line 106 "../src/widgets/ScrollWidget.vala"
	if (!gtk_widget_get_mapped ((GtkWidget*) self)) {
#line 553 "ScrollWidget.c"
		GtkAdjustment* _tmp0_;
		GtkAdjustment* _tmp1_;
#line 107 "../src/widgets/ScrollWidget.vala"
		_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 107 "../src/widgets/ScrollWidget.vala"
		_tmp1_ = _tmp0_;
#line 107 "../src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp1_, (gdouble) 0);
#line 108 "../src/widgets/ScrollWidget.vala"
		block85_data_unref (_data85_);
#line 108 "../src/widgets/ScrollWidget.vala"
		_data85_ = NULL;
#line 108 "../src/widgets/ScrollWidget.vala"
		return;
#line 568 "ScrollWidget.c"
	}
#line 112 "../src/widgets/ScrollWidget.vala"
	if (force_start) {
#line 572 "ScrollWidget.c"
		gboolean _tmp2_ = FALSE;
		GtkSettings* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 113 "../src/widgets/ScrollWidget.vala"
		_tmp3_ = gtk_settings_get_default ();
#line 113 "../src/widgets/ScrollWidget.vala"
		g_object_get (_tmp3_, "gtk-enable-animations", &_tmp4_, NULL);
#line 113 "../src/widgets/ScrollWidget.vala"
		_tmp5_ = _tmp4_;
#line 113 "../src/widgets/ScrollWidget.vala"
		if (_tmp5_) {
#line 113 "../src/widgets/ScrollWidget.vala"
			_tmp2_ = _data85_->animate;
#line 587 "ScrollWidget.c"
		} else {
#line 113 "../src/widgets/ScrollWidget.vala"
			_tmp2_ = FALSE;
#line 591 "ScrollWidget.c"
		}
#line 113 "../src/widgets/ScrollWidget.vala"
		if (_tmp2_) {
#line 595 "ScrollWidget.c"
			GdkFrameClock* _tmp6_;
			GtkAdjustment* _tmp7_;
			GtkAdjustment* _tmp8_;
			gdouble _tmp9_;
			gdouble _tmp10_;
			GtkAdjustment* _tmp11_;
			GtkAdjustment* _tmp12_;
			gdouble _tmp13_;
			gdouble _tmp14_;
#line 114 "../src/widgets/ScrollWidget.vala"
			_tmp6_ = gtk_widget_get_frame_clock ((GtkWidget*) self);
#line 114 "../src/widgets/ScrollWidget.vala"
			self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp6_);
#line 115 "../src/widgets/ScrollWidget.vala"
			self->priv->end_time = self->priv->start_time + TRANSITION_DURATION;
#line 116 "../src/widgets/ScrollWidget.vala"
			_tmp7_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 116 "../src/widgets/ScrollWidget.vala"
			_tmp8_ = _tmp7_;
#line 116 "../src/widgets/ScrollWidget.vala"
			_tmp9_ = gtk_adjustment_get_value (_tmp8_);
#line 116 "../src/widgets/ScrollWidget.vala"
			_tmp10_ = _tmp9_;
#line 116 "../src/widgets/ScrollWidget.vala"
			self->priv->transition_diff = -_tmp10_;
#line 117 "../src/widgets/ScrollWidget.vala"
			_tmp11_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 117 "../src/widgets/ScrollWidget.vala"
			_tmp12_ = _tmp11_;
#line 117 "../src/widgets/ScrollWidget.vala"
			_tmp13_ = gtk_adjustment_get_value (_tmp12_);
#line 117 "../src/widgets/ScrollWidget.vala"
			_tmp14_ = _tmp13_;
#line 117 "../src/widgets/ScrollWidget.vala"
			self->priv->transition_start_value = _tmp14_;
#line 118 "../src/widgets/ScrollWidget.vala"
			gtk_widget_add_tick_callback ((GtkWidget*) self, _scroll_widget_scroll_up_tick_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 633 "ScrollWidget.c"
		} else {
			GtkAdjustment* _tmp15_;
			GtkAdjustment* _tmp16_;
#line 120 "../src/widgets/ScrollWidget.vala"
			_tmp15_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 120 "../src/widgets/ScrollWidget.vala"
			_tmp16_ = _tmp15_;
#line 120 "../src/widgets/ScrollWidget.vala"
			gtk_adjustment_set_value (_tmp16_, (gdouble) 0);
#line 643 "ScrollWidget.c"
		}
	} else {
		GtkAdjustment* _tmp25_;
		GtkAdjustment* _tmp26_;
		gulong _tmp27_;
#line 123 "../src/widgets/ScrollWidget.vala"
		if (self->priv->scroll_up_id != ((gulong) 0)) {
#line 651 "ScrollWidget.c"
			GtkAdjustment* _tmp17_;
			GtkAdjustment* _tmp18_;
			gdouble _tmp19_;
			gdouble _tmp20_;
			GtkAdjustment* _tmp21_;
			GtkAdjustment* _tmp22_;
			gdouble _tmp23_;
			gdouble _tmp24_;
#line 124 "../src/widgets/ScrollWidget.vala"
			_tmp17_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 124 "../src/widgets/ScrollWidget.vala"
			_tmp18_ = _tmp17_;
#line 124 "../src/widgets/ScrollWidget.vala"
			_tmp19_ = gtk_adjustment_get_value (_tmp18_);
#line 124 "../src/widgets/ScrollWidget.vala"
			_tmp20_ = _tmp19_;
#line 124 "../src/widgets/ScrollWidget.vala"
			self->priv->transition_diff = -_tmp20_;
#line 125 "../src/widgets/ScrollWidget.vala"
			_tmp21_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 125 "../src/widgets/ScrollWidget.vala"
			_tmp22_ = _tmp21_;
#line 125 "../src/widgets/ScrollWidget.vala"
			_tmp23_ = gtk_adjustment_get_value (_tmp22_);
#line 125 "../src/widgets/ScrollWidget.vala"
			_tmp24_ = _tmp23_;
#line 125 "../src/widgets/ScrollWidget.vala"
			self->priv->transition_start_value = _tmp24_;
#line 126 "../src/widgets/ScrollWidget.vala"
			block85_data_unref (_data85_);
#line 126 "../src/widgets/ScrollWidget.vala"
			_data85_ = NULL;
#line 126 "../src/widgets/ScrollWidget.vala"
			return;
#line 686 "ScrollWidget.c"
		}
#line 128 "../src/widgets/ScrollWidget.vala"
		_tmp25_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 128 "../src/widgets/ScrollWidget.vala"
		_tmp26_ = _tmp25_;
#line 128 "../src/widgets/ScrollWidget.vala"
		_tmp27_ = g_signal_connect_data ((GObject*) _tmp26_, "notify::upper", (GCallback) ____lambda32__g_object_notify, block85_data_ref (_data85_), (GClosureNotify) block85_data_unref, 0);
#line 128 "../src/widgets/ScrollWidget.vala"
		self->priv->scroll_up_id = _tmp27_;
#line 696 "ScrollWidget.c"
	}
#line 104 "../src/widgets/ScrollWidget.vala"
	block85_data_unref (_data85_);
#line 104 "../src/widgets/ScrollWidget.vala"
	_data85_ = NULL;
#line 702 "ScrollWidget.c"
}

/**
   * Scroll to the very end of the scrolled window once the next
   * size_alocate occurs.
   * This will use a transition if the correct Gtk+ settings is set
   * to true
   *
   * @param animate Whether to animate/transition the change or not (default: true)
   * @param force_wait If this is set to true, we will wait for the next size_allocate
   *                   event, even if the widget is unmapped (default: false).
   */
static Block86Data*
block86_data_ref (Block86Data* _data86_)
{
#line 154 "../src/widgets/ScrollWidget.vala"
	g_atomic_int_inc (&_data86_->_ref_count_);
#line 154 "../src/widgets/ScrollWidget.vala"
	return _data86_;
#line 722 "ScrollWidget.c"
}

static void
block86_data_unref (void * _userdata_)
{
	Block86Data* _data86_;
	_data86_ = (Block86Data*) _userdata_;
#line 154 "../src/widgets/ScrollWidget.vala"
	if (g_atomic_int_dec_and_test (&_data86_->_ref_count_)) {
#line 732 "ScrollWidget.c"
		ScrollWidget* self;
#line 154 "../src/widgets/ScrollWidget.vala"
		self = _data86_->self;
#line 154 "../src/widgets/ScrollWidget.vala"
		_g_object_unref0 (self);
#line 154 "../src/widgets/ScrollWidget.vala"
		g_slice_free (Block86Data, _data86_);
#line 740 "ScrollWidget.c"
	}
}

static void
__lambda33_ (Block86Data* _data86_)
{
	ScrollWidget* self;
	gboolean _tmp0_ = FALSE;
	GtkSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 163 "../src/widgets/ScrollWidget.vala"
	self = _data86_->self;
#line 164 "../src/widgets/ScrollWidget.vala"
	_tmp1_ = gtk_settings_get_default ();
#line 164 "../src/widgets/ScrollWidget.vala"
	g_object_get (_tmp1_, "gtk-enable-animations", &_tmp2_, NULL);
#line 164 "../src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 164 "../src/widgets/ScrollWidget.vala"
	if (_tmp3_) {
#line 164 "../src/widgets/ScrollWidget.vala"
		_tmp0_ = _data86_->animate;
#line 764 "ScrollWidget.c"
	} else {
#line 164 "../src/widgets/ScrollWidget.vala"
		_tmp0_ = FALSE;
#line 768 "ScrollWidget.c"
	}
#line 164 "../src/widgets/ScrollWidget.vala"
	if (_tmp0_) {
#line 772 "ScrollWidget.c"
		GdkFrameClock* _tmp4_;
		GtkAdjustment* _tmp5_;
		GtkAdjustment* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		GtkAdjustment* _tmp9_;
		GtkAdjustment* _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		GtkAdjustment* _tmp13_;
		GtkAdjustment* _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
		GtkAdjustment* _tmp17_;
		GtkAdjustment* _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
#line 165 "../src/widgets/ScrollWidget.vala"
		_tmp4_ = gtk_widget_get_frame_clock ((GtkWidget*) self);
#line 165 "../src/widgets/ScrollWidget.vala"
		self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp4_);
#line 166 "../src/widgets/ScrollWidget.vala"
		self->priv->end_time = self->priv->start_time + TRANSITION_DURATION;
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp5_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp6_ = _tmp5_;
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp7_ = gtk_adjustment_get_upper (_tmp6_);
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp8_ = _tmp7_;
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp9_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp10_ = _tmp9_;
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp11_ = gtk_adjustment_get_page_size (_tmp10_);
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp12_ = _tmp11_;
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp13_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp14_ = _tmp13_;
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp15_ = gtk_adjustment_get_value (_tmp14_);
#line 167 "../src/widgets/ScrollWidget.vala"
		_tmp16_ = _tmp15_;
#line 167 "../src/widgets/ScrollWidget.vala"
		self->priv->transition_diff = (_tmp8_ - _tmp12_) - _tmp16_;
#line 168 "../src/widgets/ScrollWidget.vala"
		_tmp17_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 168 "../src/widgets/ScrollWidget.vala"
		_tmp18_ = _tmp17_;
#line 168 "../src/widgets/ScrollWidget.vala"
		_tmp19_ = gtk_adjustment_get_value (_tmp18_);
#line 168 "../src/widgets/ScrollWidget.vala"
		_tmp20_ = _tmp19_;
#line 168 "../src/widgets/ScrollWidget.vala"
		self->priv->transition_start_value = _tmp20_;
#line 169 "../src/widgets/ScrollWidget.vala"
		gtk_widget_add_tick_callback ((GtkWidget*) self, _scroll_widget_scroll_up_tick_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 834 "ScrollWidget.c"
	} else {
		GtkAdjustment* _tmp21_;
		GtkAdjustment* _tmp22_;
		GtkAdjustment* _tmp23_;
		GtkAdjustment* _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
		GtkAdjustment* _tmp27_;
		GtkAdjustment* _tmp28_;
		gdouble _tmp29_;
		gdouble _tmp30_;
#line 171 "../src/widgets/ScrollWidget.vala"
		_tmp21_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 171 "../src/widgets/ScrollWidget.vala"
		_tmp22_ = _tmp21_;
#line 171 "../src/widgets/ScrollWidget.vala"
		_tmp23_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 171 "../src/widgets/ScrollWidget.vala"
		_tmp24_ = _tmp23_;
#line 171 "../src/widgets/ScrollWidget.vala"
		_tmp25_ = gtk_adjustment_get_upper (_tmp24_);
#line 171 "../src/widgets/ScrollWidget.vala"
		_tmp26_ = _tmp25_;
#line 171 "../src/widgets/ScrollWidget.vala"
		_tmp27_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 171 "../src/widgets/ScrollWidget.vala"
		_tmp28_ = _tmp27_;
#line 171 "../src/widgets/ScrollWidget.vala"
		_tmp29_ = gtk_adjustment_get_page_size (_tmp28_);
#line 171 "../src/widgets/ScrollWidget.vala"
		_tmp30_ = _tmp29_;
#line 171 "../src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp22_, _tmp26_ - _tmp30_);
#line 868 "ScrollWidget.c"
	}
#line 173 "../src/widgets/ScrollWidget.vala"
	g_signal_handler_disconnect ((GObject*) self, self->priv->scroll_down_id);
#line 174 "../src/widgets/ScrollWidget.vala"
	self->priv->scroll_down_id = (gulong) 0;
#line 874 "ScrollWidget.c"
}

static void
___lambda33__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 163 "../src/widgets/ScrollWidget.vala"
	__lambda33_ (self);
#line 884 "ScrollWidget.c"
}

void
scroll_widget_scroll_down_next (ScrollWidget* self,
                                gboolean animate,
                                gboolean force_wait)
{
	Block86Data* _data86_;
	gboolean _tmp0_ = FALSE;
	gulong _tmp11_;
#line 154 "../src/widgets/ScrollWidget.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/widgets/ScrollWidget.vala"
	_data86_ = g_slice_new0 (Block86Data);
#line 154 "../src/widgets/ScrollWidget.vala"
	_data86_->_ref_count_ = 1;
#line 154 "../src/widgets/ScrollWidget.vala"
	_data86_->self = g_object_ref (self);
#line 154 "../src/widgets/ScrollWidget.vala"
	_data86_->animate = animate;
#line 155 "../src/widgets/ScrollWidget.vala"
	if (!gtk_widget_get_mapped ((GtkWidget*) self)) {
#line 155 "../src/widgets/ScrollWidget.vala"
		_tmp0_ = !force_wait;
#line 909 "ScrollWidget.c"
	} else {
#line 155 "../src/widgets/ScrollWidget.vala"
		_tmp0_ = FALSE;
#line 913 "ScrollWidget.c"
	}
#line 155 "../src/widgets/ScrollWidget.vala"
	if (_tmp0_) {
#line 917 "ScrollWidget.c"
		GtkAdjustment* _tmp1_;
		GtkAdjustment* _tmp2_;
		GtkAdjustment* _tmp3_;
		GtkAdjustment* _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		GtkAdjustment* _tmp7_;
		GtkAdjustment* _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
#line 156 "../src/widgets/ScrollWidget.vala"
		_tmp1_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 156 "../src/widgets/ScrollWidget.vala"
		_tmp2_ = _tmp1_;
#line 156 "../src/widgets/ScrollWidget.vala"
		_tmp3_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 156 "../src/widgets/ScrollWidget.vala"
		_tmp4_ = _tmp3_;
#line 156 "../src/widgets/ScrollWidget.vala"
		_tmp5_ = gtk_adjustment_get_upper (_tmp4_);
#line 156 "../src/widgets/ScrollWidget.vala"
		_tmp6_ = _tmp5_;
#line 156 "../src/widgets/ScrollWidget.vala"
		_tmp7_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 156 "../src/widgets/ScrollWidget.vala"
		_tmp8_ = _tmp7_;
#line 156 "../src/widgets/ScrollWidget.vala"
		_tmp9_ = gtk_adjustment_get_page_size (_tmp8_);
#line 156 "../src/widgets/ScrollWidget.vala"
		_tmp10_ = _tmp9_;
#line 156 "../src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp2_, _tmp6_ - _tmp10_);
#line 157 "../src/widgets/ScrollWidget.vala"
		block86_data_unref (_data86_);
#line 157 "../src/widgets/ScrollWidget.vala"
		_data86_ = NULL;
#line 157 "../src/widgets/ScrollWidget.vala"
		return;
#line 956 "ScrollWidget.c"
	}
#line 160 "../src/widgets/ScrollWidget.vala"
	if (self->priv->scroll_down_id != ((gulong) 0)) {
#line 161 "../src/widgets/ScrollWidget.vala"
		block86_data_unref (_data86_);
#line 161 "../src/widgets/ScrollWidget.vala"
		_data86_ = NULL;
#line 161 "../src/widgets/ScrollWidget.vala"
		return;
#line 966 "ScrollWidget.c"
	}
#line 163 "../src/widgets/ScrollWidget.vala"
	_tmp11_ = g_signal_connect_data ((GtkWidget*) self, "size-allocate", (GCallback) ___lambda33__gtk_widget_size_allocate, block86_data_ref (_data86_), (GClosureNotify) block86_data_unref, 0);
#line 163 "../src/widgets/ScrollWidget.vala"
	self->priv->scroll_down_id = _tmp11_;
#line 154 "../src/widgets/ScrollWidget.vala"
	block86_data_unref (_data86_);
#line 154 "../src/widgets/ScrollWidget.vala"
	_data86_ = NULL;
#line 976 "ScrollWidget.c"
}

static gboolean
scroll_widget_scroll_up_tick_cb (ScrollWidget* self,
                                 GtkWidget* widget,
                                 GdkFrameClock* frame_clock)
{
	gint64 now = 0LL;
	gdouble t = 0.0;
	GtkAdjustment* _tmp2_;
	GtkAdjustment* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkAdjustment* _tmp5_;
	GtkAdjustment* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gboolean result;
#line 181 "../src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 181 "../src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 181 "../src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (frame_clock != NULL, FALSE);
#line 182 "../src/widgets/ScrollWidget.vala"
	if (!gtk_widget_get_mapped ((GtkWidget*) self)) {
#line 1002 "ScrollWidget.c"
		GtkAdjustment* _tmp0_;
		GtkAdjustment* _tmp1_;
#line 183 "../src/widgets/ScrollWidget.vala"
		_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 183 "../src/widgets/ScrollWidget.vala"
		_tmp1_ = _tmp0_;
#line 183 "../src/widgets/ScrollWidget.vala"
		gtk_adjustment_set_value (_tmp1_, self->priv->transition_start_value + self->priv->transition_diff);
#line 184 "../src/widgets/ScrollWidget.vala"
		result = FALSE;
#line 184 "../src/widgets/ScrollWidget.vala"
		return result;
#line 1015 "ScrollWidget.c"
	}
#line 187 "../src/widgets/ScrollWidget.vala"
	now = gdk_frame_clock_get_frame_time (frame_clock);
#line 189 "../src/widgets/ScrollWidget.vala"
	t = 1.0;
#line 190 "../src/widgets/ScrollWidget.vala"
	if (now < self->priv->end_time) {
#line 191 "../src/widgets/ScrollWidget.vala"
		t = (now - self->priv->start_time) / ((gdouble) (self->priv->end_time - self->priv->start_time));
#line 1025 "ScrollWidget.c"
	}
#line 193 "../src/widgets/ScrollWidget.vala"
	t = ease_out_cubic (t);
#line 195 "../src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 195 "../src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 195 "../src/widgets/ScrollWidget.vala"
	gtk_adjustment_set_value (_tmp3_, self->priv->transition_start_value + (t * self->priv->transition_diff));
#line 196 "../src/widgets/ScrollWidget.vala"
	_tmp5_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 196 "../src/widgets/ScrollWidget.vala"
	_tmp6_ = _tmp5_;
#line 196 "../src/widgets/ScrollWidget.vala"
	_tmp7_ = gtk_adjustment_get_value (_tmp6_);
#line 196 "../src/widgets/ScrollWidget.vala"
	_tmp8_ = _tmp7_;
#line 196 "../src/widgets/ScrollWidget.vala"
	if (_tmp8_ <= ((gdouble) 0)) {
#line 196 "../src/widgets/ScrollWidget.vala"
		_tmp4_ = TRUE;
#line 1047 "ScrollWidget.c"
	} else {
#line 196 "../src/widgets/ScrollWidget.vala"
		_tmp4_ = now >= self->priv->end_time;
#line 1051 "ScrollWidget.c"
	}
#line 196 "../src/widgets/ScrollWidget.vala"
	if (_tmp4_) {
#line 197 "../src/widgets/ScrollWidget.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 198 "../src/widgets/ScrollWidget.vala"
		result = FALSE;
#line 198 "../src/widgets/ScrollWidget.vala"
		return result;
#line 1061 "ScrollWidget.c"
	}
#line 201 "../src/widgets/ScrollWidget.vala"
	result = TRUE;
#line 201 "../src/widgets/ScrollWidget.vala"
	return result;
#line 1067 "ScrollWidget.c"
}

ScrollWidget*
scroll_widget_construct (GType object_type)
{
	ScrollWidget * self = NULL;
#line 22 "../src/widgets/ScrollWidget.vala"
	self = (ScrollWidget*) g_object_new (object_type, NULL);
#line 22 "../src/widgets/ScrollWidget.vala"
	return self;
#line 1078 "ScrollWidget.c"
}

ScrollWidget*
scroll_widget_new (void)
{
#line 22 "../src/widgets/ScrollWidget.vala"
	return scroll_widget_construct (TYPE_SCROLL_WIDGET);
#line 1086 "ScrollWidget.c"
}

gdouble
scroll_widget_get_end_diff (ScrollWidget* self)
{
	gdouble result;
#line 28 "../src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 28 "../src/widgets/ScrollWidget.vala"
	result = self->priv->_end_diff;
#line 28 "../src/widgets/ScrollWidget.vala"
	return result;
#line 1099 "ScrollWidget.c"
}

void
scroll_widget_set_end_diff (ScrollWidget* self,
                            gdouble value)
{
	gdouble old_value;
#line 28 "../src/widgets/ScrollWidget.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/widgets/ScrollWidget.vala"
	old_value = scroll_widget_get_end_diff (self);
#line 28 "../src/widgets/ScrollWidget.vala"
	if (old_value != value) {
#line 28 "../src/widgets/ScrollWidget.vala"
		self->priv->_end_diff = value;
#line 28 "../src/widgets/ScrollWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, scroll_widget_properties[SCROLL_WIDGET_END_DIFF_PROPERTY]);
#line 1117 "ScrollWidget.c"
	}
}

gboolean
scroll_widget_get_scrolled_down (ScrollWidget* self)
{
	gboolean result;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkAdjustment* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	GtkAdjustment* _tmp8_;
	GtkAdjustment* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
#line 32 "../src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp4_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp5_ = _tmp4_;
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp6_ = gtk_adjustment_get_upper (_tmp5_);
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp7_ = _tmp6_;
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp8_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp9_ = _tmp8_;
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp10_ = gtk_adjustment_get_page_size (_tmp9_);
#line 33 "../src/widgets/ScrollWidget.vala"
	_tmp11_ = _tmp10_;
#line 33 "../src/widgets/ScrollWidget.vala"
	result = _tmp3_ >= ((_tmp7_ - _tmp11_) - 5);
#line 33 "../src/widgets/ScrollWidget.vala"
	return result;
#line 1167 "ScrollWidget.c"
}

gboolean
scroll_widget_get_scrolled_up (ScrollWidget* self)
{
	gboolean result;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 37 "../src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 38 "../src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_adjustment_get_value (_tmp1_);
#line 38 "../src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 38 "../src/widgets/ScrollWidget.vala"
	result = _tmp3_ <= ((gdouble) 5);
#line 38 "../src/widgets/ScrollWidget.vala"
	return result;
#line 1192 "ScrollWidget.c"
}

gboolean
scroll_widget_get_is_scrollable (ScrollWidget* self)
{
	gboolean result;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkAdjustment* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
#line 42 "../src/widgets/ScrollWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 43 "../src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 43 "../src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_adjustment_get_upper (_tmp1_);
#line 43 "../src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 43 "../src/widgets/ScrollWidget.vala"
	_tmp4_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 43 "../src/widgets/ScrollWidget.vala"
	_tmp5_ = _tmp4_;
#line 43 "../src/widgets/ScrollWidget.vala"
	_tmp6_ = gtk_adjustment_get_page_size (_tmp5_);
#line 43 "../src/widgets/ScrollWidget.vala"
	_tmp7_ = _tmp6_;
#line 43 "../src/widgets/ScrollWidget.vala"
	result = _tmp3_ > _tmp7_;
#line 43 "../src/widgets/ScrollWidget.vala"
	return result;
#line 1229 "ScrollWidget.c"
}

static void
_scroll_widget_keep_upper_func_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 53 "../src/widgets/ScrollWidget.vala"
	scroll_widget_keep_upper_func ((ScrollWidget*) self);
#line 1239 "ScrollWidget.c"
}

static void
_scroll_widget_keep_value_func_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 54 "../src/widgets/ScrollWidget.vala"
	scroll_widget_keep_value_func ((ScrollWidget*) self);
#line 1249 "ScrollWidget.c"
}

static GObject *
scroll_widget_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScrollWidget * self;
	GtkAdjustment* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
	GtkAdjustment* _tmp3_;
#line 52 "../src/widgets/ScrollWidget.vala"
	parent_class = G_OBJECT_CLASS (scroll_widget_parent_class);
#line 52 "../src/widgets/ScrollWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 52 "../src/widgets/ScrollWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCROLL_WIDGET, ScrollWidget);
#line 53 "../src/widgets/ScrollWidget.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 53 "../src/widgets/ScrollWidget.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/widgets/ScrollWidget.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify::upper", (GCallback) _scroll_widget_keep_upper_func_g_object_notify, self, 0);
#line 54 "../src/widgets/ScrollWidget.vala"
	_tmp2_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 54 "../src/widgets/ScrollWidget.vala"
	_tmp3_ = _tmp2_;
#line 54 "../src/widgets/ScrollWidget.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::value", (GCallback) _scroll_widget_keep_value_func_g_object_notify, self, 0);
#line 52 "../src/widgets/ScrollWidget.vala"
	return obj;
#line 1284 "ScrollWidget.c"
}

static void
scroll_widget_class_init (ScrollWidgetClass * klass,
                          gpointer klass_data)
{
#line 22 "../src/widgets/ScrollWidget.vala"
	scroll_widget_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/widgets/ScrollWidget.vala"
	g_type_class_adjust_private_offset (klass, &ScrollWidget_private_offset);
#line 22 "../src/widgets/ScrollWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scroll_widget_get_property;
#line 22 "../src/widgets/ScrollWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scroll_widget_set_property;
#line 22 "../src/widgets/ScrollWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = scroll_widget_constructor;
#line 22 "../src/widgets/ScrollWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = scroll_widget_finalize;
#line 22 "../src/widgets/ScrollWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCROLL_WIDGET_END_DIFF_PROPERTY, scroll_widget_properties[SCROLL_WIDGET_END_DIFF_PROPERTY] = g_param_spec_double ("end-diff", "end-diff", "end-diff", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 200, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/widgets/ScrollWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCROLL_WIDGET_SCROLLED_DOWN_PROPERTY, scroll_widget_properties[SCROLL_WIDGET_SCROLLED_DOWN_PROPERTY] = g_param_spec_boolean ("scrolled-down", "scrolled-down", "scrolled-down", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/widgets/ScrollWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCROLL_WIDGET_SCROLLED_UP_PROPERTY, scroll_widget_properties[SCROLL_WIDGET_SCROLLED_UP_PROPERTY] = g_param_spec_boolean ("scrolled-up", "scrolled-up", "scrolled-up", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/widgets/ScrollWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCROLL_WIDGET_IS_SCROLLABLE_PROPERTY, scroll_widget_properties[SCROLL_WIDGET_IS_SCROLLABLE_PROPERTY] = g_param_spec_boolean ("is-scrollable", "is-scrollable", "is-scrollable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/widgets/ScrollWidget.vala"
	scroll_widget_signals[SCROLL_WIDGET_SCROLLED_TO_START_SIGNAL] = g_signal_new ("scrolled-to-start", TYPE_SCROLL_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 22 "../src/widgets/ScrollWidget.vala"
	scroll_widget_signals[SCROLL_WIDGET_SCROLLED_TO_END_SIGNAL] = g_signal_new ("scrolled-to-end", TYPE_SCROLL_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1315 "ScrollWidget.c"
}

static void
scroll_widget_instance_init (ScrollWidget * self,
                             gpointer klass)
{
#line 22 "../src/widgets/ScrollWidget.vala"
	self->priv = scroll_widget_get_instance_private (self);
#line 27 "../src/widgets/ScrollWidget.vala"
	self->priv->balance = NONE;
#line 28 "../src/widgets/ScrollWidget.vala"
	self->priv->_end_diff = (gdouble) 200;
#line 1328 "ScrollWidget.c"
}

static void
scroll_widget_finalize (GObject * obj)
{
	ScrollWidget * self;
#line 22 "../src/widgets/ScrollWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCROLL_WIDGET, ScrollWidget);
#line 22 "../src/widgets/ScrollWidget.vala"
	G_OBJECT_CLASS (scroll_widget_parent_class)->finalize (obj);
#line 1339 "ScrollWidget.c"
}

static GType
scroll_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScrollWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scroll_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScrollWidget), 0, (GInstanceInitFunc) scroll_widget_instance_init, NULL };
	GType scroll_widget_type_id;
	scroll_widget_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "ScrollWidget", &g_define_type_info, 0);
	ScrollWidget_private_offset = g_type_add_instance_private (scroll_widget_type_id, sizeof (ScrollWidgetPrivate));
	return scroll_widget_type_id;
}

GType
scroll_widget_get_type (void)
{
	static volatile gsize scroll_widget_type_id__once = 0;
	if (g_once_init_enter (&scroll_widget_type_id__once)) {
		GType scroll_widget_type_id;
		scroll_widget_type_id = scroll_widget_get_type_once ();
		g_once_init_leave (&scroll_widget_type_id__once, scroll_widget_type_id);
	}
	return scroll_widget_type_id__once;
}

static void
_vala_scroll_widget_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	ScrollWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SCROLL_WIDGET, ScrollWidget);
#line 22 "../src/widgets/ScrollWidget.vala"
	switch (property_id) {
#line 22 "../src/widgets/ScrollWidget.vala"
		case SCROLL_WIDGET_END_DIFF_PROPERTY:
#line 22 "../src/widgets/ScrollWidget.vala"
		g_value_set_double (value, scroll_widget_get_end_diff (self));
#line 22 "../src/widgets/ScrollWidget.vala"
		break;
#line 22 "../src/widgets/ScrollWidget.vala"
		case SCROLL_WIDGET_SCROLLED_DOWN_PROPERTY:
#line 22 "../src/widgets/ScrollWidget.vala"
		g_value_set_boolean (value, scroll_widget_get_scrolled_down (self));
#line 22 "../src/widgets/ScrollWidget.vala"
		break;
#line 22 "../src/widgets/ScrollWidget.vala"
		case SCROLL_WIDGET_SCROLLED_UP_PROPERTY:
#line 22 "../src/widgets/ScrollWidget.vala"
		g_value_set_boolean (value, scroll_widget_get_scrolled_up (self));
#line 22 "../src/widgets/ScrollWidget.vala"
		break;
#line 22 "../src/widgets/ScrollWidget.vala"
		case SCROLL_WIDGET_IS_SCROLLABLE_PROPERTY:
#line 22 "../src/widgets/ScrollWidget.vala"
		g_value_set_boolean (value, scroll_widget_get_is_scrollable (self));
#line 22 "../src/widgets/ScrollWidget.vala"
		break;
#line 1398 "ScrollWidget.c"
		default:
#line 22 "../src/widgets/ScrollWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/widgets/ScrollWidget.vala"
		break;
#line 1404 "ScrollWidget.c"
	}
}

static void
_vala_scroll_widget_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	ScrollWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SCROLL_WIDGET, ScrollWidget);
#line 22 "../src/widgets/ScrollWidget.vala"
	switch (property_id) {
#line 22 "../src/widgets/ScrollWidget.vala"
		case SCROLL_WIDGET_END_DIFF_PROPERTY:
#line 22 "../src/widgets/ScrollWidget.vala"
		scroll_widget_set_end_diff (self, g_value_get_double (value));
#line 22 "../src/widgets/ScrollWidget.vala"
		break;
#line 1424 "ScrollWidget.c"
		default:
#line 22 "../src/widgets/ScrollWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/widgets/ScrollWidget.vala"
		break;
#line 1430 "ScrollWidget.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

